function ts = binaryts(a,b,stata,statb)
% Adds output of UTARBTS as valid sample time, which
% matches any of 0, >0 or -1.

% Copyright 2003-2005 The MathWorks, Inc.

m = utarbts;
if a==b
   ts = a;
elseif a==m
   ts = b;
elseif b==m
   ts = a;
elseif stata && ~statb
   ts = b;
elseif ~stata && statb
   ts = a;
elseif stata && statb
   if a==0 || b==0
      ts = a+b;
   else
      error('Incompatible Sample Times.');
   end
elseif ~stata && ~statb
   if (a>0 & b==-1) | (b>0 & a==-1)
      ts = abs(a*b);
   else
      error('Incompatible Sample Times.');
   end
end


% function ts = LOCALbinaryts(a,b,m)
% 
% if isequal(a,m)
%    ts = b;
% elseif isequal(b,m)
%    ts = a;
% elseif a==b
%    ts = a;
% elseif (a>0 & b==-1) | (b>0 & a==-1)
%    ts = abs(a*b);
% else
%    error('Incompatible Sample Times');
% end
