function newomega = elimfreqpoints(omega,TS)
% Eliminate 
if nargin==1
   TS = 0;
end

KEEPEXTRALOW = 1;
KEEPEXTRAHIGH = 2;
MINBINCNT = 4;
AVGBINCNT = 3;
if TS==0
   newomega = [];
   while length(newomega)<0.5*length(omega)
      N = hist(log10(omega),ceil(length(omega)/AVGBINCNT));
      m4 = find(N>=MINBINCNT);
      dropfront = 0;
      dropend = 0;
      if ~isempty(m4)
         if min(m4)-KEEPEXTRALOW>=1
            dropfront = sum(N(1:min(m4)-KEEPEXTRALOW-1));
         end
         if max(m4)+KEEPEXTRAHIGH<=length(N)
            dropend = sum(N(max(m4)+KEEPEXTRAHIGH+1:end));
         end
      end
      if dropfront>0 || dropend>0
         newomega = omega(dropfront+1:end-dropend);
      elseif length(omega)>15
         newomega = omega(4:end-4);
      else
         newomega = omega;
      end
      KEEPEXTRAHIGH = KEEPEXTRAHIGH+1;
      KEEPEXTRALOW = KEEPEXTRALOW+1;
   end
else
   if omega(end)*abs(TS)>0.99999*pi
      omega(end) = 0.99999*pi/abs(TS);
   end
   newomega = [];
   while length(newomega)<0.5*length(omega)
      N = hist(log10(omega),ceil(length(omega)/AVGBINCNT));
      m4 = find(N>=MINBINCNT);
      mlow = find(omega>(1e-5)*omega(end));
      dropfront1 = mlow(1)-1;
      dropfront = 0;
      if ~isempty(m4)
         if min(m4)-KEEPEXTRALOW>=1
            dropfront = sum(N(1:min(m4)-KEEPEXTRALOW-1));
         end
      end
      dropfront = min([dropfront dropfront1]);
      if dropfront>0
         newomega = omega(dropfront+1:end);
      elseif length(omega)>11
         newomega = omega(4:end);
      else
         newomega = omega;
      end
      KEEPEXTRAHIGH = KEEPEXTRAHIGH+1;
      KEEPEXTRALOW = KEEPEXTRALOW+1;
   end
end
