%GETMUTOOLSBLKSTRUCT   Get muTools block structure from Uncertain Object
%   BLK = GETMUTOOLSBLKSTRUCT(A) converts the underlying block-diagonal
%   structured uncertainty within A into the "old-style" muTools version.
%   BLK is N-by-2, where N is the number of uncertain elements in A.
%   This can be used with the not-uncertain object LFTDATA(A) to perform
%   equivalent robustness computations (such as ROBUSTSTAB and WCGAIN) in
%   the old manner.
% 
%   See also LFTDATA, MUSSV.

% Copyright 2003-2004 The MathWorks, Inc.

function B = getmutoolsblkstruct(A,allowsubs)

if nargin==1
   allowsubs = 0;
end

 try
   tmp = pvget(A,'N23BlkStructure',allowsubs);
   B = tmp.N2;
 catch
    rethrow(lasterror)
 end