function B = reportconvert(A)
% Converts Cell-type robustness report into a
% character array.  Assumes that each entry of
% the cell-array report is a 2-d char array.

% Copyright 2004 The MathWorks, Inc.

maxdim = [0 0];
szA = size(A);
for i=1:prod(szA)
   maxdim = max([maxdim;size(A{i})],[],1);
end
B = repmat(' ',[maxdim szA]);
for i=1:prod(szA)
   szAi = size(A{i});
   B(1:szAi(1),1:szAi(2),i) = A{i};
end