function out = atom(nstr,nom,varargin)
%ATOM   Constructor for the ATOM parent object.
% 
%   Note: This function is not intended for users.  Use UREAL,
%   UCOMPLEX and ULTIDYN to create specific uncertain atoms.
%
%   See also UREAL, UCOMPLEX, ULTIDYN.

% Copyright 2003-2004 The MathWorks, Inc.

%superiorto('double')

nin = nargin;
if nin==1 && isa(nstr,'atom') % class(nstr,'atom')
   out = nstr;
elseif nin>=2 && ceil(nin/2)==floor(nin/2)
   out.Name = nstr;
   out.NominalValue = nom;
   out.AutoSimplify = 'basic'; % {'off' 'obvious' 'basic' 'full'}
   out = class(out,'atom',gsref(0));
elseif nin==0
   out.Name = 'UNNAMED';
   out.NominalValue = [];
   out.AutoSimplify = 'off';
   out = class(out,'atom',gsref(0));
else
   error('Invalid constructor for ATOM.')
end

if length(varargin)>0
   out = set(out,varargin{:});
end

if ~isvalid(out)
   error('Invalid ATOM specification.');
end

