%HORZCAT  Horizontal concatenation of uncertain objects.
%  
%MAT = HORZCAT(MAT1,MAT2,...) performs a concatenation operation of 
%  MAT = [MAT1 , MAT2, ...].
%
%See also: VERTCAT

function out = horzcat(varargin)
% Copyright 2003-2004 The MathWorks, Inc.

if nargin==1
   out = varargin{1};
elseif nargin==2
   if isempty(varargin{1})
      out = varargin{2};
   elseif isempty(varargin{2})
      out = varargin{1};
   else
      a = umat(varargin{1});
      b = umat(varargin{2});
      sza = size(a);
      szb = size(b);
      if sza(1)==szb(1)
         out = [a b];
      else
         error('Atom Row dimensions are not equal')
      end
   end
elseif nargin>2
   out = horzcat([umat(varargin{1}) umat(varargin{2})],varargin{3:end});
end
