%PVGET  Get values of public uncertain atom properties.
%  
%VALUES = PVGET(MAT) returns all public values in a cell
%array VALUES.
%  
%VALUE = PVGET(SYS,PROPERTY) returns the value of the
%single property with name PROPERTY.
%  
%See also GET.

function [out,pflag,errstring] = pvget(A,property)
% Copyright 2003-2004 The MathWorks, Inc.

%disp('ATOM/pvget: should be eliminated??')
pflag = 1;
errstring = '';
switch property
case 'Name'
   out = A.Name;
case 'NominalValue'
   out = A.NominalValue;
case 'AutoSimplify'
   out = A.AutoSimplify;
case 'Size'
   out = size(A.NominalValue);
case 'PropNames'
   out.GPropNames = {'Name';'NominalValue';'AutoSimplify'};
   out.SPropNames = {'Name';'NominalValue';'AutoSimplify'};
   out.SPropDescription = {'String';'';'[''off'' | ''basic'' | ''full'']'};
otherwise
   out = [];
   pflag = 0;
   errstring = ['Invalid ATOM property: ''' property '''.'];
end
if nargout<=1 && pflag==0
   error(errstring);
end
