%PVSET  Set properties of uncertain objects.
%  
%MAT = PVSET(MAT,'Property1',Value1,'Property2',Value2,...)
%sets the values of the properties with exact names 'Property1',
%'Property2',...
%  
%See also SET.

function [A,pflag,errstring] = pvset(A,property,value)
% Copyright 2003-2004 The MathWorks, Inc.

pflag = 1;
errstring = '';
switch property
case 'Name'
   if isa(value,'char') & min(size(value))==1
      A.Name = value;
   else
      pflag = 0;
      errstring = ['ATOM Name should be a CHAR.'];
   end
case 'NominalValue'
   if isequal(size(value),size(A.NominalValue)) && isequal(class(value),class(A.NominalValue))
      A.NominalValue = value;
   else
      pflag = 0;
      errstring = ['Invalid NominalValue - both size and class must not change.'];
   end
case 'AutoSimplify'
   pv = {'off';'obvious';'basic';'full'};
   idx = find(strncmpi(pv,value,length(value)));
   if length(idx)==1
      A.AutoSimplify = pv{idx};
   else
      pflag = 0;
      errstring = ['Unknown AutoSimplify value.'];
   end
otherwise
   pflag = 0;
   errstring = ['''' property ''' is an Invalid ATOM Property'];
end
if nargout<=1 && pflag==0
   error(errstring);
end
