% REPMAT Replicate and tile an uncertain atom.
%
%  B = REPMAT(A,M,N) creates a UMAT B consisting of an M-by-N
%  tiling of copies of A.
% 
%  B = REPMAT(A,[M N]) accomplishes the same result as REPMAT(A,M,N).
% 
%  B = REPMAT(A,[M N P ...]) tiles the array A to produce a
%  M-by-N-by-P-by-... block array.  A can be N-D.
% 
%  REPMAT(A,M,N) when A is a scalar is commonly used to produce
%  an M-by-N matrix filled with A's value.
% 
%See also BLKDIAG.

function B = repmat(A,varargin)
% Copyright 2003-2004 The MathWorks, Inc.

B = repmat(umat(A),varargin{:});