function varargout = size(m,varargin)
% SIZE   Size of atom.
%    The size of an atom is given by the size of the value
%    of the 'NominalValue' property.  The syntax exactly follows the
%    conventions for the builtin SIZE function.

% Copyright 2003-2004 The MathWorks, Inc.
switch nargout
   case {0;1}
      varargout{1} = size(m.NominalValue,varargin{:});
   case 2
      [varargout{1},varargout{2}] = size(m.NominalValue,varargin{:});
   case 3
      [varargout{1},varargout{2},varargout{3}] = size(m.NominalValue,varargin{:});
   otherwise
      varargout = cell(1,max([nargout 1]));
      [varargout{:}] = size(m.NominalValue,varargin{:});
end
