%VERTCAT  Vertical concatenation of uncertain objects.
%  
%MAT = VERTCAT(MAT1,MAT2,...) performs a concatenation operation of 
%  MAT = [MAT1; MAT2; ...].
%
%See also: HORZCAT

function out = vertcat(varargin)
% Copyright 2003-2004 The MathWorks, Inc.

if nargin==1
   out = varargin{1};
elseif nargin==2
   if isempty(varargin{1})
      out = varargin{2};
   elseif isempty(varargin{2})
      out = varargin{1};
   else
      a = umat(varargin{1});
      b = umat(varargin{2});
      sza = size(a);
      szb = size(b);
%       if sza(1)==0
%          out = varargin{2};
%       elseif szb(1)==0
%          out = varargin{1};
%       elseif sza(2)==szb(2)
      if sza(2)==szb(2)
         out = [a;b];
      else
         error('Atom Column dimensions are not equal')
      end
   end
elseif nargin>2
   out = vertcat([varargin{1};varargin{2}],varargin{3:end});
end
