%ALLREALORSCALAR Check is all uncertain atoms are UREAL or scalar.

function [go,out2] = allrealorscalar(m)
% Copyright 2003-2004 The MathWorks, Inc.

% [B,C] = ALLREAL(A)
%  If all atoms in A (atomlist) are UREAL, then B==1
%  If all atoms in A (atomlist) are each either
%    UREAL, UCOMPLEX, or 1x1 UCOMPLEXM/ULTIDYN, then C==1
go = 1;
out2 = 1;
cnt = 1;
nblk = length(m.AtomCell);
while out2==1 & cnt<=nblk
   if ~isa(m.AtomCell{cnt},'ureal')
      go = 0;
      sza = size(m.AtomCell{cnt});
      switch class(m.AtomCell{cnt})
      case {'ucomplexm','ultidyn'}
         if ~isequal(sza,[1 1])
            out2 = 0;
         end
      case 'ucomplex'
         out2 = 1;
      case 'udelay'
         out2 = 1;
      otherwise
         out2 = 0;
      end
   end
   cnt = cnt + 1;
end         
