%GBLKIDX Get block index of an uncertain object.
%
%IDX = GBLKIDX(MAT,BLKID) returns the index of the uncertain atom BLKID
%inside of MAT. BLKID is a string containing the name of the uncertain
%atom of interest.
%
%See also: FIELDNAMES, FINDATOMSOFTYPE, GBLKINFO

function idx = gblkidx(m,blkid)
% Copyright 2003-2006 The MathWorks, Inc.

idx = [];
%nblk = size(m.AtomCell,1);

if isstr(blkid) && size(blkid,1)==1                
   %blknames = pvget(m,'UNames');
   %idx = strmatch(blkid,blknames,'exact');
   %idx = strmatch(blkid,m.Cache.UNames,'exact'); % cache1idea
   idx = find(sum(double(blkid))==m.Cache.UNamesCS);
   if length(idx)==1 && ~isequal(blkid,m.Cache.UNames{idx})
      idx = [];
   elseif length(idx)>1
      idx2 = strmatch(blkid,m.Cache.UNames(idx),'exact');
      idx = idx(idx2);
   end
elseif isa(blkid,'double') && floor(blkid)==ceil(blkid) && ...
 isequal(size(blkid),[1 1]) && blkid>0 && blkid<=m.Cache.nblk
   idx = blkid;
else
   error('BLKID should be CHAR or DOUBLE')
end

