%ISVALID  True if uncertain object is an uncertain atom.
%  
%[PFLG,A] = ISVALID(MAT) returns PFLG==1 (true) if the uncertain object 
%MAT is an uncertain atom, and 0 otherwise. A is the input argument MAT.

function [pflag] = isvalid(A)
% Copyright 2003-2004 The MathWorks, Inc.

pflag = true;
if isa(A.AtomCell,'cell') & isa(A.Info,'double')
   szb = size(A.AtomCell);
   if length(szb)==2 & szb(2)==1 & isequal(szb,size(A.Info)) ...
      if all(A.Info==0 | A.Info==1 | A.Info==2 | A.Info==3)
         for i=1:length(A.AtomCell)
            if ~isa(A.AtomCell{i},'atom')
               pflag = 0;
               errstr = ['Entry # ' int2str(i) ' of AtomCell is not an atom'];
            end
         end
      else
         pflag = 0;
         errstr = ['Info should be a column of 0s and 1s.       '];
      end
   else
      pflag = 0;
      errstr = ['AtomCell/Info should be columns of identical dimension'];
   end
else
   pflag = 0;
   errstr = ['Invalid DEPLIST data types'];
end
if pflag==0 & nargout==0
   error(errstr);
end
if pflag==0
   pflag = false;
end