%MKDSTR Nice display of uncertain objects.
%
%OUT = MKDSTR(MAT) returns a nice display of the uncertain object MAT.
%
%See also: DISPLAY

function out = mkdstr(m)
% Copyright 2003-2004 The MathWorks, Inc.

natoms = length(m.AtomCell);
if natoms>0
   cnames = cell(natoms,1);
   csz = cell(natoms,1);
   for i=1:length(m.AtomCell)
      cnames{i} = fliplr(['    ' pvget(m.AtomCell{i,1},'Name')]);
      sz = size(m.AtomCell{i,1});
      csz{i} = [': [' int2str(sz(1)) 'x' int2str(sz(2)) ' ' class(m.AtomCell{i,1}) ']']; 
   end
   out = [fliplr(char(cnames)) char(csz)];
else
   out = '';
end
