%PVGET  Get values of public uncertain atom properties.
%  
%VALUES = PVGET(MAT) returns all public values in a cell
%array VALUES.
%  
%VALUE = PVGET(SYS,PROPERTY) returns the value of the
%single property with name PROPERTY.
%  
%See also GET.

function [out,pflag,errstring] = pvget(m,property,varargin)
% Copyright 2003-2006 The MathWorks, Inc.

pflag = 1;
errstring = '';
switch property
case 'AtomCell'
   out = m.AtomCell;
case 'Info'
   out = m.Info;
case 'PropNames'
   %bnames = pvget(m,'UNames');
   bnames = m.Cache.UNames;
   %out.GPropNames = [bnames;{'UNames'}];
   out.GPropNames = bnames;
   out.SPropNames = bnames;
%    tmp = cell(length(m.AtomCell),1);
%    for i=1:length(m.AtomCell)
%       tmp{i,1} = class(m.AtomCell{i});
%    end
%   out.SPropDescription = tmp;
   out.SPropDescription = m.Cache.Classes;
case 'UNames'
%    nblk = length(m.AtomCell);
%    out = cell(nblk,1);
%    for i=1:nblk
%       out{i} = pvget(m.AtomCell{i,1},'Name');
%    end
   out = m.Cache.UNames;
case 'Sizes'
   out = m.Cache.Sizes;
case 'nblk'
   out = m.Cache.nblk;
otherwise

    idx = gblkidx(m,property);
    if isempty(idx)
      out = [];
      pflag = 0;
      errstring = ['Invalid DEPLIST property: ''' property '''.'];
    else
        out = m.AtomCell{idx,1};
    end
    
%     %   nblk = length(m.AtomCell);
%    nblk = m.Cache.nblk;
%    cnt = 1;
%    go = 1;   
%    while cnt<=nblk & go==1
%       %if isequal(property,pvget(m.AtomCell{cnt,1},'Name'))
%       if isequal(property,m.Cache.UNames{cnt})
%          out = m.AtomCell{cnt,1};
%          go = 0;
%       else
%          cnt = cnt + 1;
%       end
%    end
%    if go==1
%       out = [];
%       pflag = 0;
%       errstring = ['Invalid DEPLIST property: ''' property '''.'];
%    end
end
if nargout<=1 && pflag==0
   error(errstring);
end
      
      
