%DISPLAY   Pretty-print for DKITOPT objects.
% 
%DISPLAY(OBJ) is invoked by typing OBJ followed
%by a carriage return.  DISPLAY produces a custom
%display of DKITOPT objects.
% 
function display(m)
% Copyright 2003-2004 The MathWorks, Inc.

GSp = pvget(m,'PropNames');
   % Create an empty STRUCT, with all the entries from GProp as
   % fieldsnames
   nprop = length(GSp.GPropNames);
   plist = [GSp.GPropNames cell(nprop,1)]';
   if isempty(plist)
      tout = struct([]);
   else
      tout = struct(plist{:});
   end
   % Fill each field with the appropriate value
   for i=1:nprop
      B = pvget(m,GSp.GPropNames{i});
      if isa(class(B),'optunit')
         val = pvget(B,'Value');
      else
         val = B;
      end
      tout = setfield(tout,GSp.GPropNames{i},val);
   end
      % If there are no output arguments, simply display the result 
      disp('Property Object Values:')
      disp(tout);
