% function [soln]= sdn_step(a,b1,b2,c1,c2,invT,T,S,s,h,delay,k);
%
% SOLN contains 0 if gamma is too small
%               1 if norm less than gamma
%

%   Copyright 1991-2004 MUSYN Inc. and The MathWorks, Inc.
% $Revision: 1.1.6.1 $

function [soln]= sdn_step(a,b1,b2,c1,c2,invT,T,S,s,h,delay,k);

%start optimistically
soln=1;

%
tn=max(size(S));
n=tn/2;

% construct equivalent discrete system
dsdsys=sdequiv(a,b1,b2,c1,c2,invT,T,S,s,h,delay);
if isempty(dsdsys),
	soln=0;
	return
end

row2=length(c2(:,1)); col2=length(b2(1,:));
clsys=lft(dsdsys,k,col2,row2);
clpoles=pole(clsys);

%convert to continuous-time
if max(abs(clpoles))>=1,
	soln=0;
	return;
end

% XXXMINOR
% This could all be replaced with code below.
% If this is done, hinfchk.m and jwhamtst.m
% can be removed from private.
%
% gam = norm(clsys,inf); 
% if gam >=1
%    soln=0;
% else
%    soln=1;
% end
%

csys = d2c(clsys,'tustin');
[A,B,C,D] = ssdata(csys);

%call hinfchk to check the gamma value
if (max(real(eig(A)))>=0.0) | (norm(D)>=1),
	soln=0;
else
	out = hinfchk(csys); 
	if ~isempty(out),
    	soln=0;
	end
end; %if (max(real