function [b,classa,dflag] = depromote(a)
% NDLFT depromote
%
% Returns NDLFT (no demotion), DOUBLE (no blocks) or ATOM

% Copyright 2003-2004 The MathWorks, Inc.

% STATUS UNCLEAR
% at this point, the commented-out code below means that all
% extra dimensions are left intact.

classa = 'ndlft';
dflag = 0;
b = a;

% eliminate zero copies
% XXX i have commented this out, since it makes the
% strategy in SIMPLIFY not entirely correct.  SIMPLIFY separates removing
% 0-copies from depromotion.  That seemed to us to be an important distinction.
%a = rmzerocp(a);

sza = size(a);
ncop = sum(a.Copies);
[flg,pat] = isndlftatom(a);

%AtomCell = pvget(a.DepData,'AtomCell');
%lbc = length(AtomCell);
% the code below would depromote NDLFTs that are constant across all indices
%if lbc==0 & (length(sza)==2 | isndcons(a.MatrixData))
%   a = a.MatrixData(:,:,1);
%if lbc==0 & length(sza)==2 % second condition eliminated, jan 11, 2002
%if lbc==0
if ncop ==0
   b = a.MatrixData;
   dflag = 1;
elseif ncop==1
   [flg,pat] = isndlftatom(a);
   if flg==1
      b = pat;
      dflag = 1;
   end
end
