function [pflag,kpA] = isvalid(A)

% Copyright 2003-2006 The MathWorks, Inc.

kpA = A;
pflag = true;
if isa(A.MatrixData,'double') && isa(A.DepData,'atomlist') ...
   && isa(A.Copies,'double') && isa(A.Literal,'double')
   AtomCell = pvget(A.DepData,'AtomCell');
   szm = size(A.MatrixData);
   szb = size(AtomCell);
   if length(szb)==2 && szb(2)==1 && isequal(szb,size(A.Copies)) ...
      && isequal(szb,size(A.Literal))
      if all(floor(A.Copies)==ceil(A.Copies)) ...
         && all(floor(A.Literal)==ceil(A.Literal)) ...
         && all(A.Copies>=0) && all(A.Literal>=0) && all(A.Literal<=1)
         bdim = [0 0];
         for i=1:length(AtomCell)
            if isa(AtomCell{i},'atom')
               bdim = bdim + A.Copies(i)*size(AtomCell{i});
            else
               pflag = 0;
               errstr = ['Entry # ' int2str(i) ' of AtomCell is not an atom'];
            end
         end
         % XXX shall we allow LFTs with no inputs/outputs?  I think so...
         if ~(bdim(1)<=szm(2) && bdim(2)<=szm(1)) ...
            && ~(bdim(1)==0 && bdim(2)==0 && (szm(1)==0 || szm(2)==0)) 
            pflag = 0;
            errstr = ['AtomCell/Copies imply a block too large for Mdata'];
         end
      else
         pflag = 0;
         errstr = ['Copies should be a column of positive integers.' ...
                   'Literal should be a column of 0s and 1s.       '];
      end
   else
      pflag = 0;
      errstr = ['AtomCell/Copies/Literal should be columns of identical dimension'];
   end
else
   pflag = 0;
   errstr = ['Invalid NDLFT data types'];
end
if pflag==0 & nargout==0
   error(errstr);
end
if pflag==0
   pflag = false;
end