function  [blkioA,blkioB,rmsk,cmsk,bcell,copies,isort,jsort] = ...
   lftmask(A,B)

% Copyright 2003-2004 The MathWorks, Inc.

% STATUS UNCLEAR.  I believe this is correct, including 0-copy blocks.

[Arp,Acp,nblkA,ioA,blkioA] = ndlftinfo(A); % still contains ZERO-copies info
[Brp,Bcp,nblkB,ioB,blkioB] = ndlftinfo(B); % still contains ZERO-copies info
% BLKIO is [Output Input] dimensions for OPERATOR
Aatomcell = pvget(A.DepData,'AtomCell');
Batomcell = pvget(B.DepData,'AtomCell'); % these are cell arrays of atoms
bcell = [Aatomcell;Batomcell];
copies = [A.Copies;B.Copies];
UNames = [pvget(A.DepData,'UNames'); pvget(B.DepData,'UNames')];
[b,isort,jsort] = unique(double(char(UNames)),'rows');

tnblk = max(jsort);
rmsk  = [];
cmsk  = [];

% right size, right order, need merge check
bcell = atomlist(bcell(isort,1),zeros(length(isort),1));
copies = copies(isort,1);
if isempty(isort)
   isort = zeros(0,1); % forces Literal in ndlft/binop to be 0x1 in [] case
end

for idx=1:tnblk
   loc = find(jsort==idx);
   if length(loc)==1
      if loc<=nblkA
         rmsk = [rmsk Arp(loc):Arp(loc+1)-1];
         cmsk = [cmsk Acp(loc):Acp(loc+1)-1];
      else
         loc = loc - nblkA;
         rmsk = [rmsk blkioA(2)+[Brp(loc):Brp(loc+1)-1]];
         cmsk = [cmsk blkioA(1)+[Bcp(loc):Bcp(loc+1)-1]];
      end
   else
      % IT must be that
      % length(loc)==2 & loc(1)<=nblkA & loc(2)>nblkA
      loc(2) = loc(2) - nblkA;
      rmsk = [rmsk Arp(loc(1)):Arp(loc(1)+1)-1 blkioA(2)+(Brp(loc(2)):Brp(loc(2)+1)-1)];
      cmsk = [cmsk Acp(loc(1)):Acp(loc(1)+1)-1 blkioA(1)+(Bcp(loc(2)):Bcp(loc(2)+1)-1)];
      if isequal(Aatomcell{loc(1)},Batomcell{loc(2)})
         copies(idx) = A.Copies(loc(1)) + B.Copies(loc(2));
      else
         % XXX: should we provide more details about the differences?
         errStr = sprintf('Atoms named ''%s'' have different properties.',...
                     UNames{loc(1)});
         error(errStr);
      end
   end
end
    
