function out = ndlft(a1,a2,a3,a4,a5)
%
% NDLFT Constructor
%
% LFT = NDLFT(MatrixData,DepData,Copies,Literal)
%  create NDLFT, combining the 4 fields
%
% Other cases which promote beyond NDLFT
%

% Copyright 2003-2004 The MathWorks, Inc.

% STATUS OK, functional, but needs work

superiorto('double',...
   'ureal','ucomplex','ucomplexm','udyn','ultidyn',...
   'atom',...
   'ss','tf','zpk','frd');

validate = 1;
nin = nargin;
if nargin==5
   validate = a5;
   nin = nargin - 1;
end


mkatend = 1;
if nin==1
   validate = 0;
   switch class(a1)
   case {'ndlft'}
      out = a1;
      mkatend = 0;
   case {'umat' 'uss'}
      out = a1;
      mkatend = 0;
   case {'ureal' 'ucomplex' 'ucomplexm' 'udyn' 'ultidyn' 'subsys'}
      szm = size(a1);
      a2 = atomlist({a1},0);
      a1 = [zeros(szm(2),szm(1)) eye(szm(2));eye(szm(1)) zeros(szm(1),szm(2))];
      a3 = 1;
      a4 = 1;
   case {'udelay'}
      szm = size(a1);
      a2 = atomlist({a1},0);
      a1 = [zeros(szm(2),szm(1)) eye(szm(2));eye(szm(1)) zeros(szm(1),szm(2))];
      a3 = 1;
      a4 = 1;
   case 'double'
      a2 = atomlist;
      a3 = zeros(0,1);
      a4 = zeros(0,1);
   case {'ss' 'tf' 'zpk'}
      out = ss(a1);
      mkatend = 0;
   otherwise
      error('Invalid cast to NDLFT');
   end
elseif nin==4
   if ~isa(a1,'double') | ~isa(a2,'atomlist') | ~isa(a3,'double') | ~isa(a4,'double')
      error('Valid 4-argument NDLFT construction is ndlft(Mdata,DepData,Copies,Literal)');
   end
elseif nargin==0
   mkatend = 0;
   validate = 0;
   out.MatrixData = zeros(0,0);
   out.DepData = atomlist;
   out.Copies = zeros(0,1);
   out.Literal = zeros(0,1);
   out = class(out,'ndlft',gsref(0));
end
% Create OUT, if necessary
if mkatend
   out.MatrixData = a1;
   out.DepData = a2;
   out.Copies = a3;
   out.Literal = a4;
   out = class(out,'ndlft',gsref(0));
end
% Check validity of OUT.  Without any output arguments it will
% error out with appropriate error message if not valid.
%if isequal(validate,1)
if validate==1
   isvalid(out);
end