function out = ndlftred(mat,varargin)
%function out = ndlftred(mat,level,usemaxlevel,override)
%
%   MATREDUCE = NDLFTRED(MAT,LEVEL)
%
%   Default value of LEVEL is 0
%   Default value for USEMAXLEVEL is 1
%   Default value for NDLFTAUTOREDUCEFLAG is 2
%   if USEMAXLEVEL==1
%       level = max([level NDLFTAUTOREDUCEFLAG])
%   elseif USEMAXLEVEL==0
%       level = level;
%   elseif USEMAXLEVEL==-1
%       level = min([level NDLFTAUTOREDUCEFLAG])
%   end

% Copyright 2003-2004 The MathWorks, Inc.

%   to get BASIC in the case AUTOREDUCEFLAG==2 or 3
%          OBVIOUS in the case ARF==1
%          NONE in the case ARF==0
%   use:
%       ndlftred(mat,2,-1)  % 
%
%   to get whatever AUTOREDUCEFLAG is set at
%   use:
%       ndlftred(mat,0,1);

% STATUS UNCLEAR

if isa(mat,'ndlft')
   if length(mat.Copies)>0
      names = pvget(mat,'UNames');
      out = mat;
      for i=1:length(names)
         asf = pvget(pvget(out.DepData,names{i}),'AutoSimplify');
         alevel = LOCALpicklevel(asf,varargin{:});
         if alevel>0
            % NDLFTREDV note:
            % Dimensions 3-N are always exactly preserved.  Internal decisions
            % are differentiate between prod(szm(3:end))==1 or >1.
            % The details of dimensions 3-N are not considered.
            out = ndlftredv(out,names{i},alevel);
         end
      end
   else
      %XXXMINOR, this is the same as removing and DEPROMOTE, which we are
      %not aiming to do...  I think...
      %out = mat.MatrixData;
      out = mat;
   end
else
   out = mat;
end

function alevel = LOCALpicklevel(asf,level,usemaxlevel,override)

asf = find(strncmpi({'off';'obvious';'basic';'full'},asf,length(asf))) - 1;

if nargin==1
   level = [];
   usemaxlevel = [];
   override = [];
elseif nargin==2
   usemaxlevel = [];
   override = [];
elseif nargin==3
   override = [];
end
    
if isempty(level)
   level = 0;
end
if isempty(usemaxlevel)
   usemaxlevel = 1;
end
    
if usemaxlevel==1
   alevel = max([level asf]);
elseif usemaxlevel==0
   alevel = level;
elseif usemaxlevel==-1
   alevel = min([level asf]);
end

if ~isempty(override)
   alevel = override;
end