function B = parenget(A,L)

% Copyright 2003-2004 The MathWorks, Inc.

% only integer indexing is allowed
[rp,cp,nblk,iosize,blkiosize,szmd] = ndlftinfo(A);
ssubflg = 0;
trflg = 0;
if length(L)==1
   colflg = 0;
   if isa(L{1},'char') && isequal(L{1},':')
      colflg = 1;
   end
   
   if iosize(1)==1
      ridx = 1;
      cidx = L{1};
      if colflg==1;
         trflg = 1;
         cidx = 1:iosize(2);
      end
   elseif iosize(2)==1
      ridx = L{1};
      cidx = 1;
      if colflg ==1
         ridx = 1:iosize(1);
      end
   else
      error('Cannot use single index indexing on non-vector uncertain object')
   end
elseif length(L)>=2
   ridx = L{1};
   cidx = L{2};
   if isa(ridx,'char') && isequal(ridx,':')
      ridx = 1:iosize(1);
   end
   if isa(cidx,'char') && isequal(cidx,':')
      cidx = 1:iosize(2);
   end
end
if isempty(ridx) | isempty(cidx)
   if isempty(ridx)
      if isempty(cidx)
         B = ndlft(zeros(0,0),atomlist,zeros(0,1),zeros(0,1));
      else
         %warning('XXX warning 1');
         B = ndlft(zeros(0,length(cidx)),atomlist,zeros(0,1),zeros(0,1));
      end
   else
      %warning('XXX warning 2');
      B = ndlft(zeros(length(ridx),0),atomlist,zeros(0,1),zeros(0,1));
   end
elseif isa(ridx,'double') & ndims(ridx)==2 & min(size(ridx))==1 & ...
    all(imag(ridx)==0) & all(floor(ridx)==ceil(ridx)) & ...
    min(ridx)>0 & max(ridx)<=iosize(1)
   if isa(cidx,'double') & ndims(cidx)==2 & min(size(cidx))==1 & ...
       all(imag(cidx)==0) & all(floor(cidx)==ceil(cidx)) & ...
       min(cidx)>0 & max(cidx)<=iosize(2)
      B = A;
      aridx = [1:blkiosize(2) blkiosize(2)+ridx(:).'];
      acidx = [1:blkiosize(1) blkiosize(1)+cidx(:).'];
      if length(L)<=2
         B.MatrixData = reshape(A.MatrixData(aridx,acidx,:),...
             [length(aridx) length(acidx) szmd(3:end)]);
      else
         % correctly indexes into 3rd-Nth dimensions without
         % any index modification.
         tmpL.type = '()';
         tmpL.subs = L;
         tmpL.subs{1} = aridx;
         tmpL.subs{2} = acidx;
         B.MatrixData = builtin('subsref',A.MatrixData,tmpL);
      end
      %XXX THIS COLLAPSES DOWN ALL EXTRA DIMS IF THE SAME...
      %XXXX may be the dimension-losing problem we are having 06/16/2004,
      %Andy.  Comment out next 3 lines
%       if isndcons(B.MatrixData)
%          B.MatrixData = B.MatrixData(:,:,1);
%       end
      if ~isequal(sort(ridx),1:iosize(1)) | ~isequal(sort(cidx),1:iosize(2)) 
         B = simplify(B,'nodepromote','noremove');
      else
         %disp('NOTE TO US: ndlft/parenget XXX: skipped reduction');
      end
   else
      error('Invalid Column reference')
   end
else
   error('Invalid Row reference')
end         

if trflg == 1
   try 
      B = B.';
   catch
      rethrow(lasterror);
   end
end