function m = permute(m, index)

% Copyright 2003-2004 The MathWorks, Inc.

%XXXMINOR all instances of PERMUTE has documented issues.  This
% is consistent with current conclusion.
%XXXMINOR - depends on @atomlist/ALLREAL
%XXXMINOR error message mentions "ATOMS"
index = index(:).';
szmd = size(m.MatrixData);
if length(index)>=length(szmd) && isa(index,'double') && isequal(1:length(index),sort(index))
   szmd = [szmd ones(1,length(index)-length(szmd))];
   if isequal(sort(index(3:end)), 3:length(szmd))
      if index(1)==1 & index(2)==2
         m.MatrixData = permute(m.MatrixData, index);
      elseif index(1)==2 & index(2)==1
         [areal,ascalar] = allrealorscalar(m.DepData);
         if ascalar==1 %they all are scalar: ureal, ucomplex, ucomplexm, ultidyn
            m.MatrixData = permute(m.MatrixData, index);
         else
            msg = 'Dimensions 1 and 2 may be permuted only when all ATOMS are scalar.';
            error(msg);
         end
      end
   else
      msg = 'Dimensions 1 and 2 cannot be permuted with dimensions 3, 4,...';
      error(msg);
   end
else
   msg = 'ORDER contains an invalid permutation index.'
   error(msg);
end