function out = plus(A,B)
%PLUS  Addition for NDLFT objects

% Copyright 2003-2004 The MathWorks, Inc.

% STATUS BINOP
if nargin==2
   if isa(A,'ndlft') & isa(B,'ndlft')
      sza = size(A);
      szb = size(B);
      if ~isexdok(sza(3:end),szb(3:end))
         error('Array dimensions are incompatible.')
      end
      if sza(1)==szb(1) & sza(2)==szb(2)
            out = binop(A,B,'plus');
      elseif sza(1)==1 & sza(2)==1 & (szb(1)>1 | szb(2)>1)
            Aext = ones(szb(1),1)*A*ones(1,szb(2));
            out = Aext+B;        
      elseif szb(1)==1 & szb(2)==1 & (sza(1)>1 | sza(2)>1)
            Bext = ones(sza(1),1)*B*ones(1,sza(2));
            out = A+Bext;        
      else
            error('Matrix dimensions must agree.')
      end
      % XXX January 14, 2003
      %out = simplify(out,'nodepromote','noremove');
      out = simplify(out,'nodepromote','noremove');
   else
      out = plus(ndlft(A),ndlft(B));   
   end
end
