function [B1,C1,rep] = idrowcol(B,C,brep,brow,bcol,lflag)

% Copyright 2003-2004 The MathWorks, Inc.

szb = size(B);
nB = ndims(B);
szc = size(C);
nC = ndims(C);
if nB==2 && nC==2
   npts = 1;
elseif nB==3 && nC==3
   if szb(3)==szc(3)
      npts = szc(3);
   else
      error('Invalid BC pair');
   end
elseif nB==2 && nC==3
   npts = szc(3);
   B = repmat(B,[1 1 npts]);
elseif nB==3 && nC==2
   npts = szb(3);
   C = repmat(C,[1 1 npts]);
else
   error('Invalid BC pair');
end

%Find B's that are identical to each other???
grp = {};
cnt = 0;
left = 1:brep;
while length(left)>0
   i = left(1);
   left(1) = [];
   ridx = (i-1)*bcol+1:i*bcol;  % col refers to col(DELTA),hence row of M
   Bi = B(ridx,:,:);
   if lflag~=1 | norm(Bi(:))>0
      cnt = cnt + 1;
      grp{cnt} = i;
      tmpleft = left;
      for j=1:length(tmpleft)
         jl = tmpleft(j);
         ridx = (jl-1)*bcol+1:jl*bcol;
         Bj = B(ridx,:,:);
         if norm(Bi(:)-Bj(:))==0
            jlidx = find(left==jl);
            left(jlidx) = [];
            grp{cnt} = [grp{cnt} jl];
         end
      end
   else
      % Do nothing at this point
   end
end

% If LFLAG==1, then GRP pnly has the nonzero B's grouped

B1 = zeros(length(grp)*bcol,szb(2),npts);
C1 = zeros(szc(1),length(grp)*brow,npts);
grpkeep = [];
for i=1:length(grp)
   iloc = grp{i}(1);
   iidxc = (i-1)*bcol+1:i*bcol;
   iidxc2 = (iloc-1)*bcol+1:iloc*bcol;
   B1(iidxc,:,:) = B(iidxc2,:,:);
   iidxr = (i-1)*brow+1:i*brow;
   %for k=1:npts
   %   B1(iidx,:,k) = B(iidx2,:,k);
   %end
   for j=1:length(grp{i})
      jloc = grp{i}(j);
      jidxr2 = (jloc-1)*brow+1:jloc*brow;
      C1(:,iidxr,:) = C1(:,iidxr,:) + C(:,jidxr2,:);
      %for k=1:npts
      %   C1(:,iidxr,k) = C1(:,iidxr,k) + C(:,jidxr2,k);
      %end
   end
   tmp = C1(:,(i-1)*brow+1:i*brow,:);
   if norm(tmp(:))>0
      grpkeep = [grpkeep i];
   end
end
cnt = length(grpkeep);
keepC = localMkblkidx(grpkeep,brow);
keepB = localMkblkidx(grpkeep,bcol);
C1 = C1(:,keepC,:);
B1 = B1(keepB,:,:);

if lflag==1
   tot = [2 1 3];
   [C1t,B1t,rep] = idrowcol(permute(C1,tot),permute(B1,tot),cnt,bcol,brow,0);
   C1 = permute(C1t,tot);
   B1 = permute(B1t,tot);
else
   rep = cnt;
end

function blkidx = localMkblkidx(idx,width)
    % Make block index as ROW vector
    
    n = length(idx);
    nidx = reshape(idx,[1 n]);
    %idx = idx(:)'; % make it a row
    %wrep = kron(ones(1,length(idx)),1:width);
    wrep = localRepmat(1:width,[1 n]);
    %sp = kron((idx-1)*width,ones(1,width));
    %blkidx = sp + wrep;
    sp = localRepmat((idx-1)*width,[width 1]);
    blkidx = reshape(sp,[1 n*width]) + wrep;

function B = localRepmat(A,siz)
if length(A)==1
  nelems = prod(siz);
  if nelems>0
    % Since B doesn't exist, the first statement creates a B with
    % the right size and type.  Then use scalar expansion to
    % fill the array.. Finally reshape to the specified size.
    B(nelems) = A; 
    B(:) = A;
    B = reshape(B,siz);
  else
    B = A(ones(siz));
  end
elseif ndims(A)==2 & length(siz)==2
  [m,n] = size(A);
  mind = (1:m)';
  nind = (1:n)';
  mind = mind(:,ones(1,siz(1)));
  nind = nind(:,ones(1,siz(2)));
  B = A(mind,nind);
end

