function [zflag] = isndcona(a,dim)
%   Returns ZFLAG=1 if the N-d matrix A is a constant over
%   its the dimension DIM.  DIM must be >= 3.

% Copyright 2003-2004 The MathWorks, Inc.

if isa(dim,'double') & isequal(size(dim),[1 1]) & ceil(dim)==floor(dim) & ...
 imag(dim)==0 & dim>=3
   sza = size(a);
   zflag = 1;
   if dim<=length(sza) & sza(dim)>1
      atmp = shiftdim(a,dim);
      szat = size(atmp);
      nrows = prod(szat(1:end-1));
      aa = reshape(atmp,[nrows szat(end)]);
      cdiff = diff(aa,1,2);
      if any(cdiff(:)~=0)
         zflag = 0;
      end
   end
else
   error('Invalid DIM');
end
