function [zflag] = isndcons(a)
%   Returns ZFLAG=1 if the N-d matrix A is a constant over
%   its third-N dimensions.

% Copyright 2003-2004 The MathWorks, Inc.

sza = size(a);
npts = prod(sza(3:end));

aa = reshape(a,[sza(1)*sza(2) npts]);
cdiff = diff(aa,1,2);
zflag = 1;
if any(cdiff(:)~=0)
   zflag = 0;
end
