function out = ndplusr(a,b)
% addition for
%  2-D + N-D
%  N-D + 2-D
%  N-D + N-D
% For array index 3 and beyond,
% this performs automatic expansion along singleton dimensions.
% All non-singleton dimensions must agree. 

% Copyright 2003-2004 The MathWorks, Inc.

sza = size(a);
exa = sza(3:end);
szb = size(b);
exb = szb(3:end);
nda = ndims(a);
ndb = ndims(b);
if sza(1)==szb(1) & sza(2)==szb(2)
   exb = [exb ones(1,nda-ndb)];
   exa = [exa ones(1,ndb-nda)];
   nd = max([nda ndb]);
   if all(exa==exb | exa==1 | exb==1)
      aeq1 = find(exa==1);
      repa = ones(1,nd-2);
      repa(aeq1) = exb(aeq1);
      beq1 = find(exb==1);
      repb = ones(1,nd-2);
      repb(beq1) = exa(beq1);
      out = repmat(a,[1 1 repa]) + repmat(b,[1 1 repb]); 
   else
      error('Invalid extra dimensions')
   end
else
   error('Row/Column Matrix dimensions must agree.');
end

