function out = ndtimesr(a,b)
% multiplication for
%  2-D x N-D
%  N-D x 2-D
%  N-D x N-D (do purely scalar case faster)

% Copyright 2003-2004 The MathWorks, Inc.

sza = size(a);
szb = size(b);
nda = ndims(a);
ndb = ndims(b);
if sza(2)==szb(1)
   if ndims(a)==2
      out = reshape(a*reshape(b,szb(1),prod(szb(2:end))),[sza(1) szb(2:end)]);
   elseif ndims(b)==2
      ptmp = reshape(permute(a,[1 3:nda 2]),sza(1)*prod(sza(3:end)),sza(2))*b;
      out = ipermute(reshape(ptmp,[sza(1) sza(3:end) szb(2)]),[1 3:nda 2]);
   elseif nda==ndb & isequal(sza(3:end),szb(3:end)) & ...
    sza(1)==1 & sza(2)==1 & szb(2)==1
      out = reshape(a(:).*b(:),[1 1 sza(3:end)]);
   else
      exa = sza(3:end);
      exb = szb(3:end);
      exb = [exb ones(1,nda-ndb)];
      exa = [exa ones(1,ndb-nda)];
      nd = max([nda ndb]);
      if all(exa==exb | exa==1 | exb==1)
         ex = max([exa;exb],[],1);
         aeq1 = find(exa==1);
         repa = ones(1,nd-2);
         repa(aeq1) = exb(aeq1);
         beq1 = find(exb==1);
         repb = ones(1,nd-2);
         repb(beq1) = exa(beq1);
         out = zeros([sza(1) szb(2) ex]);
         atmp = repmat(a,[1 1 repa]);
         btmp = repmat(b,[1 1 repb]);
         for k=1:prod(ex)
            out(:,:,k) = atmp(:,:,k)*btmp(:,:,k);
         end
      else
         error('Invalid extra dimensions')
      end
   end
else
   error('Inner matrix dimensions must agree.');
end

