function mout = removend(m)
% If M is constant along any of the 3<->N dimensions,
% these are reduced to singletons.
%  
% Inner singleton dimensions are preserved.
%
% All trailing singleton dimensions are removed,
% automatically, by MatLab.

% Copyright 2003-2004 The MathWorks, Inc.

if isa(m,'double')
   mout = m;
   sza = size(mout);
   if length(sza)>2
      S(1).type = '()';
      for i=1:length(sza)
         S(1).subs{i} = ':';
      end
      for i=3:length(sza)
         if isndcona(mout,i)
            S(1).subs{i} = 1;
            mout = builtin('subsref',mout,S);
         end
      end
   end
else
   error('M must be double');
end
