function [a,b,c,repremain] = zizoelim(a,b,c,ra,ca,rep,zizoflg)
%  Simple reduction based on identically zero rows/columns.
%  Works on N-D too..

% Copyright 2003-2004 The MathWorks, Inc.

% this needs alot of extra baggage to handle the cases when A_{i,i}
% is not equal to zero.  Specific about Literal, Normalizer, and Range
% will determine whether it can be deleted.

del = 1;
ndel = length(del);    
while ndel>0
   sza = size(a);
   szb = size(b);
   szc = size(c);
   repremain = sza(1)/ra;
   del = [];
   for itry=1:repremain
      rows = ((itry-1)*ra+1):(itry*ra);
      notrows = 1:sza(1);
      notrows(rows) = [];
      cols = ((itry-1)*ca+1):(itry*ca);
      notcols = 1:sza(2);
      notcols(cols) = [];
      tcola = a(:,cols,:);
      tcolc = c(:,cols,:);
      if zizoflg==1
         trowa = a(rows,:,:);
         trowb = b(rows,:,:);
         if norm(trowa(:),'fro')==0 & norm(trowb(:),'fro')==0
            del = [del;itry];
         elseif norm(tcola(:),'fro')==0 & norm(tcolc(:),'fro')==0
            del = [del;itry];
         end
      else
         if norm(tcola(:),'fro')==0 & norm(tcolc(:),'fro')==0
            del = [del;itry];
         end
      end
   end
   ndel = length(del);
   if ndel>0
      ridxelim = ra*kron(del-1,ones(ra,1)) + kron(ones(ndel,1),(1:ra)');
      cidxelim = ca*kron(del-1,ones(ca,1)) + kron(ones(ndel,1),(1:ca)');
      a(:,cidxelim,:) = [];
      a(ridxelim,:,:) = [];
      b(ridxelim,:,:) = [];
      c(:,cidxelim,:) = [];
      % i don't think we should have to do this, but the empty assignment
      % collapses dimensions 3<->N, which seems like a "bug".
      nsza = size(a);
      a = reshape(a,[nsza(1) nsza(2) sza(3:end)]); 
      b = reshape(b,[nsza(1) szb(2) szb(3:end)]); 
      c = reshape(c,[szc(1) nsza(2) szc(3:end)]); 
   end
end
        
