function [m,pflag,errstring] = pvset(m,property,value)

% Copyright 2003-2004 The MathWorks, Inc.

% XXXMAJOR lots of comments in here we don't remmeber
% m.uncertainty.a = 2 is currently unallowed, would like to allow this.
%
% STATUS UNCLEAR, need to modify based on newest TMW goal.
%
   % the only valid properties are particular ATOMNAME.
   %
   % TMW's requirements:
   % Same Class, Same Size, Same Name -> do it
   %     Literal==1, replace in BlkCell
   %     Literal==0, need to absorb correctly
   %  or
   % Same Class, Same Size, Same Type, Same Data -> do it
   %   two different case...
   %     Name is not identical to any other name, 
   %     Name is same as some other name, 
   % in both cases, need to be careful about Literal
   % in 2nd case, need to be careful about name being same as other one
   %
   % NOTE: in both of these situations, ATVALUE will do the right thing,
   %        we just need to only allow ATVALUE in the instances put forth.
pflag = 1;
errstring = '';
if isequal(property,'DepData')
   OldDD = m.DepData;
   if ~isa(value,'atomlist')
      error(['Right hand side is ' class(value) ', which is invalid.']);
   end
   NewDD = value;
   ni = pvget(NewDD,'Info');
   idx = find(ni~=0);
   
   if (m.Literal(idx)==1 & ni(idx)<=2) | (m.Literal(idx)==0 & ni(idx)==2)
      m.DepData = atomlist(pvget(NewDD,'AtomCell'),zeros(size(ni)));   
   else
      % Name is different, OR data is different and literal==0 OR all different
      oldatomcell = pvget(OldDD,'AtomCell');
      newatomcell = pvget(NewDD,'AtomCell');
      newatom = newatomcell{idx};
      oldatom = oldatomcell{idx};
      szbval = size(newatom);
      % The main issue here is to make sure we don't leave the NDLFT object.
      % I think all of the code here does that.  Most comments are actually
      % reasoning/justification that the result will be an NDLFT.
      copval = m.Copies(idx);
      litval = m.Literal(idx);
      [m] = blk2ioch(m,idx,'t'); % can be DOUBLE or NDLFT
      bval = ndlft(newatom); % value is ATOM, lift it to NDLFT
      if litval==0
         bval = setlitr(bval,'all',0);
         % bval.MatrixData is just pvget(value,'Normalizer').S, see testndlftpvget.
         N = pvget(oldatom,'Normalizer');
         S = N.S; T = N.T; TR = N.Tarb;
         if ~isempty(TR) & ~LOCALisidlft(TR,szbval)
            bval = lft(bval,TR);
         end
         flag = LOCALisidlft(T,szbval);
         if flag==0
            bval = lft(bval,T);
         end
      end
      blkclose = bval;
      for cnt=2:copval
         blkclose = blkdiag(blkclose,bval);
      end
      m = lft(blkclose,m); % this should always be an NDLFT, though M could be DOUBLE
      if ~isa(m,'ndlft')
         % XXXMINOR
         errstring = ['XXX: m should be a NDLFT'];
         pflag = 0;
      end
   end
else
   % Can't set Nominal
   pflag = 0;
   errstring = ['Invalid NDLFT property: ' property];
end
if nargout<=1 && pflag==0
   error(errstring);
end
      
function flag = LOCALisidlft(T,blksz)

Tc = T-[zeros(blksz(2),blksz(1)) eye(blksz(2)); ...
   eye(blksz(1)) zeros(blksz(1),blksz(2))];
flag = all(Tc(:)==0);
