function A = rmzerocp(A)
% Remove blocks which have zero (0) copies.  Always returns NDLFT,
% so no depromotion takes place.

% Copyright 2003-2004 The MathWorks, Inc.

% STATUS OK

idx = find(A.Copies==0);
if length(idx>0)
   atomcell = pvget(A.DepData,'AtomCell');
   sinfo = pvget(A.DepData,'Info');
   atomcell(idx) = [];
   sinfo(idx) = [];
   A.Copies(idx) = [];
   A.Literal(idx) = [];
   if isempty(A.Literal)
      A.Copies = zeros(0,1);
      A.Literal = zeros(0,1);
      atomcell = cell(0,1);
      sinfo = zeros(0,1);
   end
   A.DepData = atomlist(atomcell,sinfo);
end
