function [rp,cp] = rpcp(m)

% Copyright 2003-2004 The MathWorks, Inc.

% Correct Row/Column pointers into MATRIXDATA.  Depends
% on LITERAL, since some blocks have different LITERAL==0,
% and LITERAL==1 dimensions.

nblk = length(m.DepData);
atomcell = pvget(m.DepData,'AtomCell');
rowcol = zeros(nblk,2); % rowcol of DELTA (reverse of MatrixData)
for i=1:nblk
   if m.Literal(i)==1
      rowcol(i,:) = m.Copies(i)*size(atomcell{i,1});
   else
      rowcol(i,:) = m.Copies(i)*pvget(atomcell{i,1},'BlockSize');
   end
end
cprp = cumsum([1 1;rowcol],1);
rp = cprp(:,2);   % rows of MatrixData
cp = cprp(:,1);   % columns of MatrixData

