function out = setlitr(mat,blkid,val)

% Copyright 2003-2004 The MathWorks, Inc.

% STATUS UNCLEAR
% immediate return for empty BLKID
if isempty(blkid)
   out = mat;
   return
end

[rp,cp,nblk,iosize,blkiosize,szmd] = ndlftinfo(mat);
outmatdata = mat.MatrixData;
outliteral = mat.Literal;
if isa(blkid,'char') & strcmp('all',blkid)
   blkid = (1:nblk)';
end

if isa(blkid,'cell')
   blkid = blkid(:);
end

szb = size(blkid);
if length(szb)==2 & szb(2)==1 & (isequal(val,0) | isequal(val,1))
   cblkid = class(blkid);
   switch cblkid
   case 'cell'
      useid = zeros(szb(1),1);
      cnt = 0;
      blknames = pvget(mat,'UNames');
      for k=1:szb(1)
         if isstr(blkid{k}) & min(size(blkid{k}))==1                
            idx = strmatch(blkid{k},blknames,'exact');
            if length(idx)==1
               cnt = cnt + 1;
               useid(cnt) = idx;
            end
         elseif isa(blkid{k},'double') & floor(blkid{k})==ceil(blkid{k}) & ...
          blkid{k}>0 & blkid{k}<=nblk
            cnt = cnt + 1;
            useid(cnt) = blkid{k};
         else
            idx = [];
         end
      end
      useid = useid(1:cnt,1);
   case 'double'
      useid = blkid(find(blkid>0 & blkid<=nblk & ceil(blkid)==floor(blkid)));
   otherwise
      error('BLKID should be a cell array or double')
   end
   if length(useid)~=length(blkid)
      warning('Some BLKID''s were not found')
   end

   for k=1:length(useid)
      idx = useid(k);
      if val==0 & mat.Literal(idx)==1
         atomcell = pvget(mat.DepData,'AtomCell');
         N = pvget(atomcell{idx},'Normalizer');
         S = N.S; T = N.T; TR = N.Tarb;
         szblk = size(atomcell{idx});
         if ~LOCALisidlft(S,szblk)
            cop = mat.Copies(idx);
            S11 = S(1:szblk(2),1:szblk(1));
            S12 = S(1:szblk(2),szblk(1)+1:end);
            S21 = S(szblk(2)+1:end,1:szblk(1));
            S22 = S(szblk(2)+1:end,szblk(1)+1:end);
            ridx = rp(idx):rp(idx+1)-1;
            cidx = cp(idx):cp(idx+1)-1;
            outmatdata = oneloopi(outmatdata,ridx,cidx,kron(eye(cop),S22));
            if all(size(S12)==[1 1]) & all(size(S21)==[1 1])
               outmatdata(ridx,:,:) = S12*outmatdata(ridx,:,:);
               outmatdata(:,cidx,:) = outmatdata(:,cidx,:)*S21;
            else
               fixl = kron(eye(cop),S12);
               fixr = kron(eye(cop),S21);
               for ii=1:prod(szmd(3:end))
                  outmatdata(ridx,:,ii) = fixl*outmatdata(ridx,:,ii);
                  outmatdata(:,cidx,ii) = outmatdata(:,cidx,ii)*fixr;
               end
            end
            term11 = kron(eye(cop),S11);
            for ii=1:prod(szmd(3:end))                        
               outmatdata(ridx,cidx,ii) = term11 + outmatdata(ridx,cidx,ii);
            end
         end
         outliteral(idx) = 0;
      elseif val==1 & mat.Literal(idx)==0
         atomcell = pvget(mat.DepData,'AtomCell');
         N = pvget(atomcell{idx},'Normalizer');
         S = N.S; T = N.T; TR = N.Tarb;
         szblk = size(atomcell{idx});
         if ~LOCALisidlft(T,szblk)
            cop = mat.Copies(idx);
            T11 = T(1:szblk(2),1:szblk(1));
            T12 = T(1:szblk(2),szblk(1)+1:end);
            T21 = T(szblk(2)+1:end,1:szblk(1));
            T22 = T(szblk(2)+1:end,szblk(1)+1:end);
            ridx = rp(idx):rp(idx+1)-1;
            cidx = cp(idx):cp(idx+1)-1;
            outmatdata = oneloopi(outmatdata,ridx,cidx,kron(eye(cop),T22));
            if all(size(T12)==[1 1]) & all(size(T21)==[1 1])
               outmatdata(ridx,:,:) = T12*outmatdata(ridx,:,:);
               outmatdata(:,cidx,:) = outmatdata(:,cidx,:)*T21;
            else
               fixl = kron(eye(cop),T12);
               fixr = kron(eye(cop),T21);
               for ii=1:prod(szmd(3:end))
                  outmatdata(ridx,:,ii) = fixl*outmatdata(ridx,:,ii);
                  outmatdata(:,cidx,ii) = outmatdata(:,cidx,ii)*fixr;
               end
            end
            term11 = kron(eye(cop),T11);
            for ii=1:prod(szmd(3:end))                        
               outmatdata(ridx,cidx,ii) = term11 + outmatdata(ridx,cidx,ii);
            end
         end
         if ~isempty(TR) & ~LOCALisidlft(TR,szblk)
            T11 = TR(1:szblk(2),1:szblk(1));
            T12 = TR(1:szblk(2),szblk(1)+1:end);
            T21 = TR(szblk(2)+1:end,1:szblk(1));
            T22 = TR(szblk(2)+1:end,szblk(1)+1:end);
            outmatdata = oneloopi(outmatdata,ridx,cidx,kron(eye(cop),T22));
            if all(size(T12)==[1 1]) & all(size(T21)==[1 1])
               outmatdata(ridx,:,:) = T12*outmatdata(ridx,:,:);
               outmatdata(:,cidx,:) = outmatdata(:,cidx,:)*T21;
            else
               fixl = kron(eye(cop),T12);
               fixr = kron(eye(cop),T21);
               for ii=1:prod(szmd(3:end))
                  outmatdata(ridx,:,ii) = fixl*outmatdata(ridx,:,ii);
                  outmatdata(:,cidx,ii) = outmatdata(:,cidx,ii)*fixr;
               end
            end
            term11 = kron(eye(cop),T11);
            for ii=1:prod(szmd(3:end))                        
               outmatdata(ridx,cidx,ii) = term11 + outmatdata(ridx,cidx,ii);
            end
         end
         outliteral(idx) = 1;
      end
   end
   % order of blocks is preserved by SETLITR
   out = ndlft(outmatdata,mat.DepData,mat.Copies,outliteral);
else
   error('Invalid BLKID or VAL')
end

function flag = LOCALisidlft(T,blksz)
Tc = T-[zeros(blksz(2),blksz(1)) eye(blksz(2)); ...
   eye(blksz(1)) zeros(blksz(1),blksz(2))];
flag = all(Tc(:)==0);
