function out = tio2blk(m,addatom,cop,lit)
% Adds ADDATOM to the bottom of DepData.  This has the effect
% of star-producting ADDATOM around the top channels of M.  This
% is the reason for the 't' in the name.

% Copyright 2003-2004 The MathWorks, Inc.

% XXXOK, XXXUNDOC
if nargin==2
   cop = 1;
   lit = 1;
elseif nargin==3
   lit = 1;
end

szm = size(m);
if any(size(addatom)>szm([2 1]))
   error('Invalid dimensions');
else
   out = m;
   sinfo = pvget(m.DepData,'Info');
   atomcell = pvget(m.DepData,'AtomCell');
   nblk = length(atomcell);
   % dynamically grow the 3 fields
   atomcell{nblk+1,1} = addatom;
   sinfo(nblk+1,1) = 0;
   out.DepData = atomlist(atomcell,sinfo);
   out.Copies(nblk+1,1) = cop;
   out.Literal(nblk+1,1) = lit;
end


