function out = vertcat(varargin)

% Copyright 2003-2004 The MathWorks, Inc.
% STATUS BINOP
if nargin==1
   out = varargin{1};
elseif nargin==2
   if isa(varargin{1},'ndlft') & isa(varargin{2},'ndlft')
      sza = size(varargin{1});
      szb = size(varargin{2});
      if ~isexdok(sza(3:end),szb(3:end))
         error('Array dimensions are incompatible.')
      end
      if sza(1)==0
         out = varargin{2};
         if sza(2)>0 & sza(2)~=szb(2)
            warning('Concatenation involves an empty array with incorrect number of columns.');
         end
      elseif szb(1)==0
         out = varargin{1};
         if szb(2)>0 & szb(2)~=sza(2)
            warning('Concatenation involves an empty array with incorrect number of columns.');
         end
      elseif sza(2)==szb(2)
         out = binop(varargin{1},varargin{2},'vertcat');
      else
         msg = 'All rows in the bracketed expression must have the same\nnumber of columns.';
         msg = sprintf(msg);
         error(msg);
      end
      out = simplify(out,'nodepromote','noremove');
   else
      out = vertcat(ndlft(varargin{1}),ndlft(varargin{2}));
   end

elseif nargin>2
   out = vertcat(vertcat(ndlft(varargin{1}),ndlft(varargin{2})),varargin{3:end});
end
