% function [out] = zerocopies(mat,blkid)
%
% Similar to DELBLK, but leaves the block listed, just with 0 copies.

% Copyright 2003-2004 The MathWorks, Inc.

% STATUS UNCLEAR
function [out] = zerocopies(mat,blkid)

[rp,cp,nblk,iosize,blkiosize,szmd] = ndlftinfo(mat);
idx = gblkidx(mat,blkid);
fflg = 1;
if isempty(idx)
   fflg = 0;
   out = mat;      % if block doesn't exist, just pass back MAT, XXX should it error now?
else
   newDepData = mat.DepData;
   newCopies = mat.Copies;
   newCopies(idx) = 0;
   newLiteral = mat.Literal;
   newLiteral(idx) = 0;
   ridx = 1:szmd(1);
   ridx(rp(idx):rp(idx+1)-1) = [];
   nrdel = rp(idx+1)-rp(idx);
   cidx = 1:szmd(2);
   cidx(cp(idx):cp(idx+1)-1) = [];
   ncdel = cp(idx+1)-cp(idx);
   newszmd = szmd;
   newszmd([1 2]) = newszmd([1 2]) - [nrdel ncdel];
   % This should correctly reserve dimensions 3<->N
   newMatrixData = zeros(newszmd);
   newMatrixData(1:length(ridx),1:length(cidx),:) = mat.MatrixData(ridx,cidx,:);
   %if length(newCopies)>0
      % decision -- always return an NDLFT.  Use DEPROMOTE
      % to reduce it to a DOUBLE in the case that NBLK==0.
      out = ndlft(newMatrixData,newDepData,newCopies,newLiteral);
   %else
   %   out = newMatrixData;
   %end
end

