%PVGET  Get values of public OPTUNIT object properties.
%  
%VALUES = PVGET(MAT) returns all public values in a cell
%array VALUES.
%  
%VALUE = PVGET(SYS,PROPERTY) returns the value of the
%single property with name PROPERTY.
%  
%See also GET.

% Copyright 2003-2004 The MathWorks, Inc.
function [out,pflag,errstring] = pvget(m,property)

pflag = 1;
errstring = '';

switch property
case {'Name'}
   out = m.Name;
case {'Value'}
   out = m.Value;
case {'Default'}
   out = m.Default;
case {'String'}
   out = m.String;
case {'PublicFlag'}
   out = m.PublicFlag;
case 'PropNames'
   out.GPropNames = [{'Name';'Value';'Default';'String';'PublicFlag'}];
   out.SPropNames = [{'Value'}];
   out.SPropDescription = [{m.String}];
otherwise
   out = [];
   pflag = 0;
   errstring = ['Invalid OPTUNIT property: ''' property '''.'];
end
if nargout<=1 && pflag==0
   error(errstring);
end
