%PVSET  Set properties of OPTUNIT objects.
%  
%OPT = PVSET(OPT,'Property1',Value1,'Property2',Value2,...)
%sets the values of the properties with exact names 'Property1',
%'Property2',...
%  
%See also SET.

% Copyright 2003-2004 The MathWorks, Inc.
function [m,pflag,errstring] = pvset(m,property,value)

pflag = 1;
errstring = '';
switch property
case {'Name'}
   m.Name = value;
case {'Value'}
   m.Value = value;
case {'Default'}
   m.Default = value;
case {'String'}
   m.String = value;
case {'PublicFlag'}
   m.PublicFlag = value;
otherwise
   pflag = 0;
   errstring = ['Invalid OPTUNIT property: ' property];
end
if nargout<=1 && pflag==0
   error(errstring);
end
