%MKDSTR Nice display of UCOMPLEX objects.
%
%OUT = MKDSTR(MAT) returns a nice display of the UCOMPLEX object MAT.
%
%See also: DISPLAY

% Copyright 2003-2004 The MathWorks, Inc.
function [dispStr,dispStr2] = mkdstr(arg1)

if isempty(arg1.Data)
   dispStr = 'Empty complex parameter';
   return
end

Types = {'Radius';'Percentage'};
thistype = Types{arg1.Data(2)};
LeadStr = ['Uncertain Complex Parameter: '];
%LeadStr = 'ucomplex: ';

switch thistype
case 'Radius'
   rad = pvget(arg1,'Radius');
   dispStr = [LeadStr 'Name ' pvget(arg1.atom,'Name') ...
      ', NominalValue ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', Radius ' num2str(rad,3)];
   dispStr2 =  [...
      'complex, nominal = ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', radius = ' num2str(rad,3)];
case 'Percentage'
   pc = pvget(arg1,'Percentage');
   dispStr = [LeadStr 'Name ' pvget(arg1.atom,'Name') ...
      ', NominalValue ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ',  +/- ' num2str(pc,3) '%'];
   dispStr2 = [...
      'complex, nominal = ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ',  +/- ' num2str(pc,3) '%'];
end
