%PVSET  Set properties of UCOMPLEXM objects.
%  
%MAT = PVSET(MAT,'Property1',Value1,'Property2',Value2,...)
%sets the values of the properties with exact names 'Property1',
%'Property2',...
%  
%See also SET.

% Copyright 2003-2004 The MathWorks, Inc.
function [p,pflag,errstring] = pvset(p,property,value)

pflag = 1;
errstring = ' ';
switch property
case {'Name','NominalValue','AutoSimplify'}
   [A,pflag,errstring] = pvset(p.atom,property,value);
   if pflag==1
      p.atom = A;
   end
case 'WL'
   if isa(value,'double') & ndims(value)==2
      szp = size(p.atom);
      szv = size(value);
      if szp(1)==szv(1)
         if rank(value)==szv(2) && szv(1)==szv(2)
            p.WL = value;
         else
            pflag = 0;
            errstring = ['WL should be invertible.'];
         end
      else
         pflag = 0;
         errstring = ['Row-dimensions of NominalValue and WL should be equal.'];
      end
   else
      pflag = 0;
      errstring = ['WL must be a square, invertible, 2-D DOUBLE.'];
   end
case 'WR'
   if isa(value,'double') & ndims(value)==2
      szp = size(p.atom);
      szv = size(value);
      if szp(2)==szv(2)
         if rank(value)==szv(2) && szv(1)==szv(2)
            p.WR = value;
         else
            pflag = 0;
            errstring = ['WR should be invertible.'];
         end
      else
         pflag = 0;
         errstring = ['Column-dimensions of NominalValue and WR should be equal.'];
      end
   else
      pflag = 0;
      errstring = ['WR must be a square, invertible, 2-D DOUBLE.'];
   end
end
if nargout<=1 && pflag==0
   error(errstring);
end
