%PVSET  Set properties of UDYN objects.
%  
%MAT = PVSET(MAT,'Property1',Value1,'Property2',Value2,...)
%sets the values of the properties with exact names 'Property1',
%'Property2',...
%  
%See also SET.

% Copyright 2003-2004 The MathWorks, Inc.
function [p,pflag,errstring] = pvset(p,property,value)

pflag = 1;
errstring = '';
switch property
case 'Lip'
   if isa(value,'double') & isequal(size(value),[1 1]) & ...
    imag(value)==0 & value>0
      p.Lip = value;
   else
      pflag = 0;
      errstring = 'Invalid Lipschitz';
   end
case 'ioSize'
   value = value(:).';
   if ndims(value)==2 & all(size(value)==[1 2]) & isa(value,'double') ...
    & all(value>0) & all(floor(value)==ceil(value))
      A = pvset(p.atom,'NominalValue',zeros(value));
      p.atom = A;
   else
      pflag = 0;
      errstring = 'ioSize should be a 1x2 DOUBLE';
   end
case {'Name','NominalValue','AutoSimplify'}
   [A,pflag,errstring] = pvset(p.atom,property,value);
   if pflag==1
      p.atom = A;
   end
end
if nargout<=1 && pflag==0
   error(errstring);
end
