%BINOP Binary operation for UFRD objects.

function out = binop(A,B,op,n1,n2)
% Copyright 2003-2005 The MathWorks, Inc.

% BINOP for UFRD

% XXXOK

Ts = binaryts(pvget(A,'Ts'),pvget(B,'Ts'),isstatic(A),isstatic(B));

switch op
case 'mtimes'
   ResponseData = A.ResponseData*B.ResponseData;
   DS = A.dynamicsys*B.dynamicsys;
case {'append' 'blkdiag'}
   ResponseData = blkdiag(A.ResponseData, B.ResponseData);
   DS = utAppend(A.dynamicsys,B.dynamicsys);
case 'horzcat'
   ResponseData = [A.ResponseData B.ResponseData];
   DS = [A.dynamicsys B.dynamicsys];
case 'plus'
   ResponseData = A.ResponseData + B.ResponseData;
   DS = A.dynamicsys+B.dynamicsys;
case 'starp'   
   temp = n1;
   n1 = n2;
   n2 = temp; 
   ResponseData = lft(A.ResponseData,B.ResponseData,n1,n2);
          
   szA = size(A);
   szB = size(B);
   indy1 = szA(1)-n2+1:szA(1);
   indu1 = szA(2)-n1+1:szA(2);
   indy2 = 1:n1;
   indu2 = 1:n2;
   % XXXMINOR
   DS = utLFT(A.dynamicsys,B.dynamicsys,indu1,indy1,indu2,indy2);
case 'lft'
   ResponseData = lft(A.ResponseData,B.ResponseData,n1,n2);

   szA = size(A);
   szB = size(B);
   indy1 = szA(1)-n2+1:szA(1);
   indu1 = szA(2)-n1+1:szA(2);
   indy2 = 1:n1;
   indu2 = 1:n2;
   DS = utLFT(A.dynamicsys,B.dynamicsys,indu1,indy1,indu2,indy2);
   % Note, STAR directly calls LFT, so no need to have STAR in BINOP
case 'mldivide'
   ResponseData = A.ResponseData\B.ResponseData;
   %DS = A.dynamicsys\B.dynamicsys;
   DS = utInv(A.dynamicsys) * B.dynamicsys;  % mldivide
case 'mrdivide'
   ResponseData = A.ResponseData/B.ResponseData;
   %DS = A.dynamicsys/B.dynamicsys;
   DS = A.dynamicsys * utInv(B.dynamicsys);  % mrdivide
case 'vertcat'
   ResponseData = [A.ResponseData; B.ResponseData];
   DS = [A.dynamicsys;B.dynamicsys];
end

szRD = size(ResponseData);
if length(szRD)==2  || ( length(szRD)>= 3 && szRD(3)==1 )
   ResponseData = repmat( ResponseData, [1 1 length(A.Frequency) ones(1,length(szRD)-3)] );   
end
out = ufrd(ResponseData,A.Frequency,'UNITS',A.Units,Ts,DS);
