%DEPROMOTE Demote the class of UFRD if possible.
%
%[B,CLASSA,DFLAG] = DEPROMOTE(A). A is an uncertain FRD. DEPROMOTE
%returns B which minimum class to which A belongs, CLASSA which is the
%string 'ufrd' and DFLAG which is 1 if depromotion was possible.
%
%See also: SIMPLIFY

function [b,classa,dflag] = depromote(a)
% Copyright 2003-2004 The MathWorks, Inc.

classa = 'ufrd';
[tmpb,tclassa,tdflag] = depromote(a.ResponseData);
% since a UFRD may just have one point, it is possible that
% the depromotion returns an ATOM.  in that case, we do nothing.
if tdflag==1 & isa(tmpb,'double')
   b = frd(tmpb,a.Frequency,'Units',a.Units);
   %XXXDS
   set(b,'InputName',pvget(a.dynamicsys,'InputName'),...
      'OutputName',pvget(a.dynamicsys,'OutputName'),...
      'InputGroup',LOCALnewg2oldg(pvget(a.dynamicsys,'InputGroup')),...
      'OutputGroup',LOCALnewg2oldg(pvget(a.dynamicsys,'OutputGroup')),...
      'Ts',a.Ts,...
      'Notes',pvget(a.dynamicsys,'Notes'),...
      'UserData',pvget(a.dynamicsys,'UserData'));
   dflag = 1;
else
   b = a;
   dflag = 0;
end

function AIG = LOCALnewg2oldg(IG)

   f = fieldnames(IG);
   AIG = cell(length(f),2);
   for i=1:length(f)
      AIG{i,1} = getfield(IG,f{i});
      AIG{i,2} = f{i};
   end
