%GBLKINFO Get block information of a UFRD object.
%
%[IDX,COPIES,ROW,COL] = GBLKINFO(SYS,BLKID) returns the index, IDX, of the 
%uncertain atom BLKID, number of copies, COPIES, of BLKID in SYS, and the
%row, ROW, and column, COL, location of the uncertain atom in the uncertain
%matrix SYS. BLKID is a string containing the name of the uncertain
%atom of interest.
%
%See also: FIELDNAMES, FINDATOMSOFTYPE, GBLKIDX

function [idx,copies,row,col] = gblkinfo(sys,blkid)
% Copyright 2003-2004 The MathWorks, Inc.

%function [idx,copies,row,col] = gblkinfo(mat,blkid)

[idx,copies,row,col] = gblkinfo(sys.ResponseData,blkid);