function boo = isct(sys)
%ISCT  True for continuous-time UFRD models.
%
%   ISCT(SYS) returns 1 (true) if the UFRD model
%   SYS is continuous (zero sampling time) or if
%   if it is a static gain.
%
%   See also ISDT, ISSTATIC.

% Copyright 2004 The MathWorks, Inc.

boo = sys.Ts==0 || isstatic(sys);

