function static = isstatic(sys)
%ISSTATIC  True for static gains
%
%   ISSTATIC(SYS) returns 1 (true) if the LTI model SYS is a 
%   static gain, and 0 (false) otherwise.
%
%   For LTI arrays, ISSTATIC(SYS) is true if all models in the
%   array are static gains.
%

% Copyright 2003-2004 The MathWorks, Inc.
MatrixData = pvget(sys.ResponseData,'MatrixData');
difference = diff(MatrixData,1,3);
static = ~any(difference(:));
