function B = loadobj(A)
% New versions of atomlist objects have a Cache field.
% Objects loaded from memory may not have this new field
% so we need to add it on.
%
%

% Pull apart data structure down to atomlist
As = struct(A);
RDs = struct(As.ResponseData);
NDs = struct(RDs.NDlftData);
DDs = struct(NDs.DepData);

% Build correct atomlist (constructor will add Cache)
DD = atomlist(DDs.AtomCell,DDs.Info);

% Build correct ndlft:
% LFT = NDLFT(MatrixData,DepData,Copies,Literal)
ND = ndlft(NDs.MatrixData,DD,NDs.Copies,NDs.Literal);

% Build correct umat (lift up from an ndlft)
RD = umat(ND);

% Build correct ufrd:
% SYS = UFRD(RD,Frequency,'Units',Units,Ts,dynamicsys);
B = ufrd(RD,As.Frequency,'Units',As.Units,As.Ts,As.dynamicsys);
