%MKHEADER Create header for display of uncertain UFRD objects
%
%See also: DISPLAY

% Copyright 2003-2004 The MathWorks, Inc.
function out = mkheader(m)

%XXXDISPLAY
szm = size(m.ResponseData);
if (szm(1))==1
   ystr = [int2str(szm(1)) ' Output, '];
else
   ystr = [int2str(szm(1)) ' Outputs, '];
end
if (szm(2))==1
   ustr = [int2str(szm(2)) ' Input,'];
else
	ustr = [int2str(szm(2)) ' Inputs,'];
end
Ts = pvget(m,'Ts');
if Ts==0
   tsstr = ' Continuous System';
elseif Ts>0
   tsstr = [' Discrete System, Ts = ' num2str(Ts)];
elseif Ts==-1
   tsstr = [' Discrete System, unspecified Ts'];
else
   tsstr = [' Static System, unspecified Ts'];
end

ioStr = [ystr ustr tsstr];

if length(szm)==2
   arrstr = [];
   if prod(szm)==0
     Npts = 0;
  else
     Npts = 1;
  end
elseif length(szm)==3
   Npts = szm(3);
   arrstr = [];
elseif length(szm)==4
   Npts = szm(3);
   arrstr = [' [array, ' int2str(szm(4)) ' x 1]'];
elseif length(szm)>4
   Npts = szm(3);
   arrstr = [int2str(szm(4))];
   for i=5:length(szm)
      arrstr = [arrstr ' x ' int2str(szm(i))];
   end
   arrstr = [' [array, ' arrstr ']'];
end

arrstrnpts = [', ' int2str(Npts) ' Frequency points'];
out = [ioStr arrstr arrstrnpts];



