%MTIMES  Multiplication for UFRD objects

% Copyright 2003-2004 The MathWorks, Inc.
function out = mtimes(A,B)

if ~isa(A,'ufrd') 
   A = lift2ufrd(A,B.Frequency,B.Units);
elseif ~isa(B,'ufrd')
   B = lift2ufrd(B,A.Frequency,A.Units);
else   
   % Check frequency vectors
   try
      % give priority to rad/s if both FRD's
      [freq,units] = freqcheck(A.Frequency,A.Units,B.Frequency,B.Units);
   catch einfo
      throw(einfo)
   end
end

sza = size(A);
szb = size(B);
if sza(2)==szb(1)
   if ~isexdok(sza(4:end),szb(4:end))
      error('Invalid extra dimensions')
   end
   try
      out = binop(A,B,'mtimes');
   catch einfo
      throw(einfo)
   end
elseif sza(1)==1 & sza(2)==1 & szb(1)>0 & szb(2)>0
   Aext = A;
   for i=2:szb(1)
      Aext = blkdiag(Aext,A);
   end
   out = Aext*B;
elseif szb(1)==1 & szb(2)==1 & sza(1)>0 & sza(2)>0
   Bext = B;
   for i=2:sza(2)
     Bext = blkdiag(Bext,B);
   end
   out = A*Bext;
else
   error('In SYS1*SYS2, systems must have compatible dimensions.');
end
