%PLUS  Addition for UFRD objects

% Copyright 2003-2004 The MathWorks, Inc.
function out = plus(A,B)


if ~isa(A,'ufrd') 
   A = lift2ufrd(A,B.Frequency,B.Units);
elseif ~isa(B,'ufrd')
   B = lift2ufrd(B,A.Frequency,A.Units);
else   
   % Check frequency vectors
   try
      % give priority to rad/s if both FRD's
      [freq,units] = freqcheck(A.Frequency,A.Units,B.Frequency,B.Units);
   catch einfo
      throw(einfo);
   end
end

sza = size(A);
szb = size(B);
if sza(1)==1 & sza(2)==1 & (szb(1)>1 | szb(2)>1)
      Aext = ones(szb(1),1)*A*ones(1,szb(2));
      out = Aext+B;        
elseif szb(1)==1 & szb(2)==1 & (sza(1)>1 | sza(2)>1)
      Bext = ones(sza(1),1)*B*ones(1,sza(2));
      out = A+Bext;        
elseif sza(1)==szb(1) & sza(2)==szb(2)
      if ~isexdok(sza(4:end),szb(4:end))
         error('Invalid extra dimensions')
      end
      try
         out = binop(A,B,'plus');
      catch einfo
         throw(einfo);
      end
else
      error('In SYS1+SYS2, systems must have same number of inputs and outputs.');
end


