function B = lift2ufrd(A,Frequency,Units)
% A is anything lower.  The Freq/Units properties
% of B are added to A to make it a UFRD.  THis is like
% a promotion of A to B (which is UFRD)
%
% double, umat

% Copyright 2003-2004 The MathWorks, Inc.

   switch class(A)
   case 'double'
      npts = length(Frequency);
      na = ndims(A);
      perA = permute(A,[1 2 na+1 3:na]);
      % double repmat across third dimension 
      A = umat(repmat(perA,[ 1 1 npts ones(1,na-2) ]));
      %call constructor, now that 3rd dimension is correct
      B = ufrd(A,Frequency,'Units',Units,utarbts);
   case 'umat'
      if allatomslti(A)
         npts = length(Frequency);
         na = ndims(A);
         tmp = permute(A,[1 2 na+1 3:na]);
         % should check that all atoms are LTI XXXMINOR
         dd = ones(1,length(size(A)));
         dd(3) = npts;
         % umat repmat
         tmp = repmat(tmp,dd);
         %call constructor, now that 3rd dimension is correct
         B = ufrd(tmp,Frequency,'Units',Units,utarbts);
      else
         error('Some atoms are not linear, time-invariant, conversion to UFRD is not defined');
      end
   case {'ss' 'zpk' 'tf'}
      % XXXMINOR, XXXTS uses A's sample time
      B = ufrd(uss(A),Frequency,'Units',Units);
   case 'uss'
      % XXXMINOR, XXXTS uses A's sample time
      B = ufrd(A,Frequency,'Units',Units);
   case {'udelay'}
      B = ufrd(frd(A.NominalValue,Frequency,'Units',Units));
   case {'ureal' 'ucomplex' 'ultidyn' 'ucomplexm'}
      B = lift2ufrd(umat(A),Frequency,Units);
   case {'frd'}
      if isequal(A.Frequency,Frequency(:)) & isequal(A.Units,Units)
         B = ufrd(A);
      else
         error('UFRD and FRD do not have the same Frequencies');
      end
   otherwise
      % XXXMINOR this should not ever happen, since we control all calls to
      % LIFT2UFRD.  Shall we delete it?
      error([class(A) ' Not ready']);
   end
