function sys = uss(varargin)

% Copyright 2004 The MathWorks, Inc.

% For a UFRD, the USS converter does nothing, preserving the
% UFRD.  See LTI/USS for more details.  
nin = nargin;
nvp = 0;
i = 1;
while nin>i && isa(varargin{nin-i},'char')
   nvp = nvp + 1;
   i = i + 2;
end
ain = nin - 2*nvp;

if nvp==0
   if ain==1  % USS(UFRD)
      sys = varargin{1}; 
   elseif ain==5 % USS(U/A/D,U/A/D,U/A/D,U/A/D,UFRD)
      cain = zeros(1,5);
      for i=1:4
         cain(i) = isa(varargin{i},'double') || isa(varargin{i},'ureal') || ...
            isa(varargin{i},'ucomplex') || isa(varargin{i},'ucomplexm') || ...
            isa(varargin{i},'udyn') || isa(varargin{i},'ultidyn') || ...
            isa(varargin{i},'umat');
      end
      cain(5) = isa(varargin{5},'ufrd');
      if all(cain==1)
         sys = uss(umat(varargin{1}),umat(varargin{2}),...
            umat(varargin{3}),umat(varargin{4}),varargin{5});
      else
         badarg = find(cain==0);
         error(['Argument #' int2str(badarg(1)) ' is incorrect class']);
      end
   else 
      error('Invalid argument list')
   end
else
   sys = uss(varargin{1:ain});
   sys = set(sys,varargin{ain+1:end});
end