%MKDSTR Nice display of ULTIDYN objects.
%
%OUT = MKDSTR(MAT) returns a nice display of the ULTIDYN object MAT.
%
%See also: DISPLAY

% Copyright 2003-2004 The MathWorks, Inc.
function [dispStr,dispStr2] = mkdstr(arg1)

LeadStr1 = 'Uncertain GainBounded LTI Dynamics: ';
LeadStr2 = 'Uncertain PositiveReal LTI Dynamics: ';
sza = size(arg1.atom);
dimstr = [int2str(sza(1)) 'x' int2str(sza(2))];

switch arg1.Type
case 'GainBounded'
   dispStr = [LeadStr1 'Name ' pvget(arg1.atom,'Name') ...
      ', ' dimstr ', Gain Bound = ' num2str(arg1.Bound,3)];
   dispStr2 = [dimstr ' LTI, max. gain = ' num2str(arg1.Bound,3)];
case 'PositiveReal'
   dispStr = [LeadStr2 'Name ' pvget(arg1.atom,'Name') ...
      ', ' dimstr ', M+M'' >= 2*('  num2str(arg1.Bound,3) ')'];
   dispStr2 = [dimstr ' LTI, pos. real bound = ' num2str(arg1.Bound,3)];
otherwise
   error('Invalid Type')
end
