%APPEND  Group uncertain matrices by appending their inputs and outputs.
%  
%MAT = APPEND(MAT1,MAT2, ...) produces the aggregate matrix
% 
%                [ MAT1  0       ]
%          MAT = [  0   MAT2     ]
%                [           .   ]
%                [             . ]
% 
%APPEND concatenates the input and output vectors of the uncertain
%matrices MAT1, MAT2,... to produce the resulting matrix MAT.
% 
%If MAT1,MAT2,... are arrays of uncertain matrices, APPEND returns an 
%uncertain array MAT of the same size where 
%  MAT(:,:,k) = APPEND(MAT1(:,:,k),MAT2(:,:,k),...) .
% 
%See also SERIES, PARALLEL, FEEDBACK.
function out = append(varargin)

% Copyright 2003-2004 The MathWorks, Inc.
out = blkdiag(varargin{:});
