%BINOP Binary operation for UMAT objects.

function out = binop(A,B,op,n1,n2);
% Binary operation for UMAT objects.  Both A and
% B must be UMAT objects.

% Copyright 2003-2004 The MathWorks, Inc.

% XXXCONSOLIDATE why are we doing this?  Couldn't these go in the method?
% XXXOK, XXXMINOR (bottom)
switch op
case 'plus'
   mat = A.NDlftData+B.NDlftData;
case 'minus'
   mat = A.NDlftData-B.NDlftData;
case 'horzcat'
   mat = [A.NDlftData B.NDlftData];
case 'blkdiag'
   mat = blkdiag(A.NDlftData,B.NDlftData);
case 'vertcat'
   mat = [A.NDlftData;B.NDlftData];
case 'mtimes'
   mat = A.NDlftData*B.NDlftData;
case 'starp'
   mat = lft(A.NDlftData,B.NDlftData,n2,n1);
case 'lft'
   % call STARP with reversed arguments
   mat = lft(A.NDlftData,B.NDlftData,n1,n2);
case 'mldivide'
   mat = A.NDlftData\B.NDlftData;
case 'mrdivide'
   mat = A.NDlftData/B.NDlftData;
otherwise
   % This case can be eliminated, since we call BINOP.
   error(['The operation  ''' op '''  is not supported.']);
end
out = umat(mat);
