%DIFF  Difference and approximate derivative of UMAT objects.
%   DIFF(X), for an uncertain vector X, is 
%      [X(2)-X(1)  X(3)-X(2) ... X(n)-X(n-1)].
%   DIFF(X), for an uncertain matrix X, is the matrix of row differences,
%       [X(2:n,:) - X(1:n-1,:)].
%   DIFF(X), for an UMAT N-D array X, is the difference along the first
%      row or column dimension of X.
%
%See also: REPMAT

function out = diff(mat)
%

% Copyright 2003-2004 The MathWorks, Inc.

% XXXCOMMENT XXXOK XXXMINOR are we allowed to have this?
szm = size(mat);
if szm(1)==1
   dim = szm(2) - 1;
   rfac = [[-eye(dim);zeros(1,dim)]+[zeros(1,dim);eye(dim)]];
   out = mat*rfac;
else
   dim = szm(1) - 1;
   lfac = [[-eye(dim) zeros(dim,1)]+[zeros(dim,1) eye(dim)]];
   out = lfac*mat;
end