%FLIPLR Flip uncertain matrix left-right
%
%B = FLIPLR(A) returns A with columns flipped in the left-right
%direction, that is, about a vertical axis.
%
%If A is a row vector, then FLIPLR(A) returns an UMAT vector of the same 
%length with the order of its elements reversed. If A is an UMAT column 
%vector, then FLIPLR(A) simply returns A.
%
%See also: FLIPUD, UMAT

function out = fliplr(mat)
%

% Copyright 2003-2004 The MathWorks, Inc.
% XXXCOMMENT XXXOK XXXMINOR are we allowed to have this?

szm = size(mat);
L.type = '()';
L.subs = {':' [szm(2):-1:1]};
out = subsref(mat,L);
