%GBLKINFO Get block information of a UMAT object.
%
%[IDX,COPIES,ROW,COL] = GBLKINFO(MAT,BLKID) returns the index, IDX, of the 
%uncertain atom BLKID, number of copies, COPIES, of BLKID in MAT, and the
%row, ROW, and column, COL, location of the uncertain atom in the uncertain
%matrix MAT. BLKID is a string containing the name of the uncertain
%atom of interest.
%
%See also: FIELDNAMES, FINDATOMSOFTYPE, GBLKIDX, UMAT

function [idx,copies,row,col] = gblkinfo(mat,blkid)
%function [idx,copies,row,col] = gblkinfo(mat,blkid)

% Copyright 2003-2004 The MathWorks, Inc.
%XXXOK, XXXMINOR does anyone call this? NATOMSEES, SIMPLIFY
%XXXCONSOLIDATION, based on above, this can be removed???
[idx,copies,row,col] = gblkinfo(mat.NDlftData,blkid);