%GUNCIDX Get unceratin atom index of a UMAT object.
%
%IDX = GUNCDX(MAT) returns the index of all the uncertain atoms inside 
%of MAT. IDX is a vector of numbers.
%
%See also: FIELDNAMES, FINDATOMSOFTYPE, GBLKINFO, GBLKINFO, UMAT

function idx = guncidx(m)

% Copyright 2003-2004 The MathWorks, Inc.

atomcell = pvget(pvget(m.NDlftData,'DepData'),'AtomCell');
nblk = length(atomcell);
tr = zeros(nblk,1);
for i=1:nblk
   trtmp = pvget(atomcell{i},'Traits');
   tr(i) = trtmp.uncertain;
end
idx = find(tr);