%ISVALID  True if UMAT is just an uncertain atom.
%  
%[PFLG,A] = ISVALID(MAT) returns PFLG==1 (true) if the uncertain matrix 
%MAT is an uncertain atom, and 0 otherwise. A is the input argument MAT.
%  
%See also UMAT.

function [pflag,A] = isvalid(A)

% Copyright 2003-2004 The MathWorks, Inc.

%XXXMINOR, error handling, throwing of error messages, etc
% doesn't seem well thought out.
pflag = true;
if isa(A.NDlftData,'ndlft')
   if ~isvalid(A.NDlftData)
      pflag = false;
      if nargout<=1
         error('NDlftData is an invalid NDLFT object.');
      end
   end
else
   pflag = false;
   if nargout<=1
      error('Invalid UMAT fields');
   end
end