%MLDIVIDE  Left division for UMAT objects.
%  
%MAT = MLDIVIDE(MAT1,MAT2) is invoked by MAT=MAT1\MAT2.
%and is equivalent to MAT = INV(MAT1)*MAT2.
%  
%See also MRDIVIDE, INV, MTIMES, UMAT.

function out = mldivide(a,b)

% Copyright 2003-2004 The MathWorks, Inc.

%XXXCOMMENT, XXXOK, XXXHELP generally ok.
if isa(a,'umat') & isa(b,'umat')
   sza = size(a);
   szb = size(b);
   if ~isexdok(sza(3:end),szb(3:end))
      estr = 'Array dimensions are incompatible.';
      error(estr)
   end
   if sza(1)==szb(1) & sza(1)==sza(2)
     try
        out = binop(a,b,'mldivide');
     catch
        rethrow(lasterror)
      end
      
   elseif sza(1)==1 & sza(2)==1
     try
        out = binop(diag(a*ones(1,szb(1))),b,'mldivide');
     catch
        rethrow(lasterror)
      end
   else
      estr = 'In A\B, A must be square, and A and B have the same number of rows.';
      error(estr);
   end
else
   out = mldivide(umat(a),umat(b));
end
