%MPOWER  Repeated product of UMAT objects.
%  
%MATK = MPOWER(MAT,K) is invoked by MAT^K where MAT is any 
%UMAT object with the same number of rows and columns, and K must be 
%an integer.  The result is the UMAT MODK which is an UMAT object, 
%describing
%   * if K>0, MAT * ... * MAT (K times) 
%   * if K<0, INV(MAT) * ... * INV(MAT) (K times)
%   * if K=0, the static gain EYE(SIZE(MAT)).
%  
%See also  PLUS, MTIMES, UMAT.

function B = mpower(A,N)

% Copyright 2003-2004 The MathWorks, Inc.

%XXXOK, XXXCOMMENT
sza = size(A);
if sza(1)==sza(2)
   if isa(N,'double') & ndims(N)==2 & all(size(N)==[1 1]) & ...
         ceil(N)==floor(N)
      if N<0
         A = inv(A);
      end
      if N==0
         B = eye(sza(1));
      elseif N==1
         B = A;
      else
         B = A;
         for i=2:N
            B = A*B;
         end
      end
   else
      error('N must be an integer.');
   end
else
   error('Matrix must be square.');
end