%MRDIVIDE  Right division for UMAT objects.
%  
%MAT = MLRIVIDE(MAT1,MAT2) is invoked by MAT=MAT1/MAT2.
%and is equivalent to MAT = MAT1*INV(MAT2).
%  
%See also MLDIVIDE, INV, MTIMES, UMAT.
function out = mrdivide(a,b)

% Copyright 2003-2004 The MathWorks, Inc.

%XXXCOMMENT
if isa(a,'umat') & isa(b,'umat')
   sza = size(a);
   szb = size(b);
   if ~isexdok(sza(3:end),szb(3:end))
      estr = 'Array dimensions are incompatible.';
      error(estr)
   end
   if sza(2)==szb(2) & szb(1)==szb(2)
      try
         out = binop(a,b,'mrdivide');
      catch
         rethrow(lasterror)
      end
   elseif szb(1)==1 & szb(2)==1
      try
         out = binop(a,diag(b*ones(1,sza(2))),'mrdivide');
      catch
         rethrow(lasterror)
      end
   else
      estr = 'In A/B, B must be square, and A and B have the same number of columns.';
      error(estr);
   end
else
   out = mrdivide(umat(a),umat(b));
end