function out = mtimes(A,B)
%MTIMES  Multiplication for UMAT objects

% Copyright 2003-2004 The MathWorks, Inc.
%XXXDS, check out the display for scalar*Matrix, and reversed.  should
% that be a WARNING?  otherwise XXXOK
if nargin==2
   if isa(A,'umat') & isa(B,'umat')
      sza = size(A);
      szb = size(B);
      if ~isexdok(sza(3:end),szb(3:end))
         error('Array dimensions are incompatible.')
      end
      if sza(2)==szb(1)
         try
            out = binop(A,B,'mtimes');
         catch
            rethrow(lasterror)
         end
            % REDUCTION takes place in NDLFT/BINOP (called by UMAT/BINOP)
      elseif sza(1)==1 & sza(2)==1
         if szb(1)>1 & szb(2)==1
               disp('UMAT/MTIMES: scalar*Matrix, with single column matrix.')
               disp('             If appropriate, recompute as Matrix*scalar')
               disp('             for better parameter management');
         end
         tmpa = A;
         for j=2:szb(1)
               tmpa = blkdiag(tmpa,A);
         end
         out = tmpa*B; 
      elseif szb(1)==1 & szb(2)==1
         if sza(1)==1 & sza(2)>1
               disp('UMAT/MTIMES: Matrix*scalar, with single row matrix.')
               disp('             If appropriate, recompute as scalar*Matrix')
               disp('             for better parameter management');
         end
         tmpb = B;
         for j=2:sza(2)
               tmpb = blkdiag(tmpb,B);
         end
         out = A*tmpb; 
      else
         error('Inner matrix dimensions must agree.')
      end
   else
      out = mtimes(umat(A),umat(B));
   end
end
