function n = ndims(a)
%NDIMS  Number of dimensions for UMAT objects.
%
%N = NDIMS(UM) returns the number of dimensions of
%the uncertain matrix UM.  A single UMAT matrix has two 
%dimensions (rows and columns).  An array of UMAT matrices 
%has 2+p dimensions, where p>=2 is the number of array 
%dimensions.  For example, a 2-by-3-by-4 array of uncertain
% matrices has 2+3=5 dimensions.
%
%See also SIZE.

% Copyright 2003-2004 The MathWorks, Inc.
n = length(size(a));