function out = plus(A,B)
%PLUS  Addition for UMAT objects

% Copyright 2003-2004 The MathWorks, Inc.
if nargin==2
   if isa(A,'umat') & isa(B,'umat')
      sza = size(A);
      szb = size(B);
      if ~isexdok(sza(3:end),szb(3:end))
         error('Array dimensions are incompatible.')
      end
      if sza(1)==szb(1) & sza(2)==szb(2)
         try
            out = binop(A,B,'plus');
         catch
            rethrow(lasterror)
         end
         % REDUCTION takes place in NDLFT/BINOP (called by UMAT/BINOP)
      elseif sza(1)==1 & sza(2)==1 & (szb(1)>1 | szb(2)>1)
         Aext = ones(szb(1),1)*A*ones(1,szb(2));
         out = Aext+B;        
      elseif szb(1)==1 & szb(2)==1 & (sza(1)>1 | sza(2)>1)
         Bext = ones(sza(1),1)*B*ones(1,sza(2));
         out = A+Bext;        
      else
         error('Matrix dimensions must agree.')
      end
   else
      out = plus(umat(A),umat(B));   
   end
end