%PVGET  Get values of public UMAT properties.
%  
%VALUES = PVGET(MAT) returns all public values in a cell
%array VALUES.
%  
%VALUE = PVGET(SYS,PROPERTY) returns the value of the
%single property with name PROPERTY.
%  
%See also GET.

function [out,pflag,errstring] = pvget(m,property,varargin)

% Copyright 2003-2004 The MathWorks, Inc.

%XXXOK, looks fine, but... XXXMINOR?
pflag = 1;
errstring = '';
[rp,cp,nblk,iosize,blksz,szmd] = umatinfo(m);
% if isjustanatom(m)  (ie. m is m.BlkCell{1}
%    out = pvget(m.BlkCell{1},property);
% else
switch property
case {'MatrixData' 'Copies' 'AtomCell' 'Literal' 'N23BlkStructure' ...
      'BlkInfoStructure' 'UNames' 'NominalValue' 'MofMDelta'}
   % N23BlkStructure allows for 3rd ALLOWSUBS argument,  that is what the
   % varargin is for.  NominalValue also allows for a 3rd argument which is
   % the list of variables that are being set to nominal.
   out = pvget(m.NDlftData,property,varargin{:});
case 'PropNames'
   out.GPropNames = [{'NominalValue';'Uncertainty'}];
   out.SPropNames = [{'Uncertainty'}];
   out.SPropDescription = {'not explicitly set by user, gateway to uncertain atoms'};
case {'Instance'}
   out = usample(m);
case {'DELTAofMDelta'}
   out = umat(pvget(m.NDlftData,property));
case {'theDELTAasNDLFT'}
   out = pvget(m.NDlftData,'DELTAofMDelta');
case 'NDlftData'
   out = m.NDlftData;
case {'DepData' , 'Uncertainty'}
   out = pvget(m.NDlftData,'DepData');
otherwise
   out = [];
   pflag = 0;
   errstring = ['Invalid UMAT property: ''' property '''.'];
end
if nargout<=1 && pflag==0
   error(errstring);
end
      
