%SUM Sum of UMAT array elements.
%
%B = sum(A) returns sums along different dimensions of an UMAT array. 
%
%If A is a vector, sum(A) returns the sum of the elements. 
%
%If A is a matrix, sum(A) treats the columns of A as vectors, returning 
%a row vector of the sums of each column. 
%
%If A is a multidimensional array, sum(A) treats the values along the 
%first non-singleton dimension as vectors, returning an array of 
%row vectors. 
%
%See also: DIFF

function out = sum(mat)

% Copyright 2003-2004 The MathWorks, Inc.

% XXXMINOR what about summing along dimension #2?
% what about other dimensions?  what does it mean?
szm = size(mat);
if szm(1)==1
   out = mat*ones(szm(2),1);
else
   out = ones(1,szm(1))*mat;
end