%MKDSTR Nice display of UREAL objects.
%
%OUT = MKDSTR(R) returns a nice display of the IREAL object R.
%
%See also: DISPLAY

% Copyright 2003-2004 The MathWorks, Inc.
function [dispStr,dispStr2] = mkdstr(arg1)

% if isempty(arg1.Data)
%     dispStr = 'Empty UREAL parameter';
%     dispStr2 = 'Empty UREAL parameter';
%     return
% end

LeadStr = 'Uncertain Real Parameter: ';
switch arg1.Data(3)
case 2
   pm = pvget(arg1,'PlusMinus');
   addstr = sprintf('[%g  %g]',pm(1),pm(2));
   dispStr = [LeadStr 'Name ' pvget(arg1.atom,'Name') ...
      ', NominalValue ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', variability = ' addstr  ...
      ];
   dispStr2 = ['real, nominal = ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', variability = ' addstr  ...
      ];
case 3
   pc = pvget(arg1,'Percentage');
   addstr = sprintf('[%g  %g]%%',pc(1),pc(2));
   dispStr = [LeadStr 'Name ' pvget(arg1.atom,'Name') ...
      ', NominalValue ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', variability = ' addstr  ...
      ];
   dispStr2 = ['real, nominal = ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', variability = ' addstr  ...
      ];
case 1
   rg = pvget(arg1,'Range');
   addstr = sprintf('[%g  %g]',rg(1),rg(2));
   dispStr = [LeadStr 'Name ' pvget(arg1.atom,'Name') ...
      ', NominalValue ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', Range ' addstr ...
      ];
   dispStr2 = ['real, nominal = ' num2str(pvget(arg1.atom,'NominalValue'),3) ...
      ', range = ' addstr  ...
      ];
end
