%BINOP Binary operation for USS objects.

function out = binop(A,B,op,n1,n2)
% Copyright 2003-2005 The MathWorks, Inc.

%XXXOK
Ts = binaryts(A.Ts,B.Ts,isstatic(A),isstatic(B));
fbname = 'RCASTRESERVED';
StateName = [A.StateName;B.StateName];
switch op
case 'mtimes'
   % fool LTIMULT so as to not need system data
   uresult = uss2umat(A,fbname)*uss2umat(B,fbname);
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
   out = uss(UmatData,StateName,Ts,mtimes(A.dynamicsys,B.dynamicsys));
case {'blkdiag','append'}
   uresult = blkdiag(uss2umat(A,fbname),uss2umat(B,fbname));
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
   out = uss(UmatData,StateName,Ts,utAppend(A.dynamicsys,B.dynamicsys));
case 'horzcat'
   uresult = [uss2umat(A,fbname) uss2umat(B,fbname)];
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
   out = uss(UmatData,StateName,Ts,horzcat(A.dynamicsys,B.dynamicsys));
case 'plus'
   uresult = uss2umat(A,fbname)+uss2umat(B,fbname);
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
   out = uss(UmatData,StateName,Ts,plus(A.dynamicsys,B.dynamicsys));
case 'starp'
   temp = n1;
   n1 = n2;
   n2 = temp;

   uresult = lft(uss2umat(A,fbname),uss2umat(B,fbname),n1,n2);
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
         
   szA = size(A);
   szB = size(B);
   indy1 = szA(1)-n2+1:szA(1);
   indu1 = szA(2)-n1+1:szA(2);
   indy2 = 1:n1;
   indu2 = 1:n2;
   DS = utLFT(A.dynamicsys,B.dynamicsys,indu1,indy1,indu2,indy2);
   out = uss(UmatData,StateName,Ts,DS);

case 'lft'
   uresult = lft(uss2umat(A,fbname),uss2umat(B,fbname),n1,n2);
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
         
   szA = size(A);
   szB = size(B);
   indy1 = szA(1)-n2+1:szA(1);
   indu1 = szA(2)-n1+1:szA(2);
   indy2 = 1:n1;
   indu2 = 1:n2;
   DS = utLFT(A.dynamicsys,B.dynamicsys,indu1,indy1,indu2,indy2);
   out = uss(UmatData,StateName,Ts,DS);

case 'vertcat'
   uresult = [uss2umat(A,fbname);uss2umat(B,fbname)];
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
   out = uss(UmatData,StateName,Ts,vertcat(A.dynamicsys,B.dynamicsys));
case 'mldivide'
   uresult = uss2umat(A,fbname)\uss2umat(B,fbname);
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
   %out = uss(UmatData,StateName,Ts,mldivide(A.dynamicsys,B.dynamicsys));
   out = uss(UmatData,StateName,Ts,mtimes(utInv(A.dynamicsys),B.dynamicsys));
case 'mrdivide'
   uresult = uss2umat(A,fbname)/uss2umat(B,fbname);
   UmatData = blk2ioch(uresult,fbname,'t','unchanged');
   StateName = [A.StateName;B.StateName];
%   out = uss(UmatData,StateName,Ts,mrdivide(A.dynamicsys,B.dynamicsys));
   out = uss(UmatData,StateName,Ts,mtimes(A.dynamicsys,utInv(B.dynamicsys)));
end
