%DEPROMOTE Demote the class of USS if possible.
%
%[B,CLASSA,DFLAG] = DEPROMOTE(A). A is an uncertain USS. DEPROMOTE
%returns B which minimum class to which A belongs, CLASSA which is the
%string 'uss' and DFLAG which is 1 if depromotion was possible.
%
%See also: SIMPLIFY

% Copyright 2003-2006 The MathWorks, Inc.
function [b,classa,dflag] = depromote(a)

%XXXMINOR - jumbled code, even right at beginning...
dflag = 1;
classa = class(a);
depdata = pvget(a.UmatData,'DepData');
md = pvget(a.UmatData,'MatrixData');
if length(a.StateName)==0
   % XXX: if there are no states, the LTI fields associated with
   % I/O management could be moved into the RCData field within
   % the UmatData.  This is not currently being done, as the line
   % is commented out.
   % a.UmatData = pvset(a.UmatData,'RCData',rcmanage(a.lti));
   b = depromote(a.UmatData);
   %elseif length(pvget(depdata,'AtomCell'))==0 & isreal(md)
elseif length(pvget(depdata,'AtomCell'))==0
   szmd = size(a);
   Nx = length(a.StateName);
   Amat = zeros([Nx Nx szmd(3:end)]);
   Amat(:,:,:) = md(1:Nx,1:Nx,:);
   Bmat = zeros([Nx szmd(2) szmd(3:end)]);
   Bmat(:,:,:) = md(1:Nx,Nx+1:end,:);
   Cmat = zeros([szmd(1) Nx szmd(3:end)]);
   Cmat(:,:,:) = md(Nx+1:end,1:Nx,:);
   Dmat = zeros([szmd(1) szmd(2) szmd(3:end)]);
   Dmat(:,:,:) = md(Nx+1:end,Nx+1:end,:);
%    Old code, eliminated Nov05, as LTI changed
%    b = ss(Amat,Bmat,Cmat,Dmat,ds2lti(a.dynamicsys,0));
%    set(b,'Ts',utarbts(a.Ts),'StateName',a.StateName);
   b = ss(Amat,Bmat,Cmat,Dmat);
   namevalues = [pnames(a.dynamicsys)';pvget(a.dynamicsys)'];
   b = pvset(b,namevalues{:});
   b = pvset(b,'StateName',a.StateName);
   b = setTs(b,utarbts(a.Ts)); 
else
   b = a;
   dflag = 0;
end
