%FLIPLR Flip uncertain system left-right
%
%B = FLIPLR(A) returns A with inputs flipped in the left-right
%direction, that is, about a vertical axis.
%
%If A is a row vector, then FLIPLR(A) returns an USS vector of the same 
%length with the order of its elements reversed. If A is an USS column 
%vector, then FLIPLR(A) simply returns A.
%
%See also: FLIPUD

% Copyright 2003-2004 The MathWorks, Inc.
function out = fliplr(mat)

szm = size(mat);
out = mat(:,szm(2):-1:1);
