%FLIPUD Flip uncertain system up-down.
%
%B = FLIPUD(A) returns A with outputs flipped in the up-down direction,
%that is, about a horizontal axis.
%
%If A is a column vector, then FLIPUD(A) returns an USS vector of the same 
%length with the order of its elements reversed. If A is an USS row 
%vector, then FLIPUD(A) simply returns A.
%
%See also: FLIPLR

% Copyright 2003-2004 The MathWorks, Inc.
function out = flipud(mat)

szm = size(mat);
out = mat(szm(1):-1:1,:);