%HORZCAT  Horizontal concatenation of USS objects.
%  
%MAT = HORZCAT(MAT1,MAT2,...) performs a concatenation operation of 
%  MAT = [MAT1 , MAT2, ...].
%
%See also: VERTCAT

% Copyright 2003-2004 The MathWorks, Inc.
function out = horzcat(varargin)

if nargin==1
   out = varargin{1};
elseif nargin==2
   if isa(varargin{1},'uss') & isa(varargin{2},'uss')
      A = varargin{1};
	   B = varargin{2};
      sza = size(A);
      szb = size(B);
      if ~isexdok(sza(3:end),szb(3:end))
         error('Array dimensions are incompatible.')
      end
      
      if sza(2)==0 && (sza(1)==szb(1) | sza(1)==0)
         out = B;
      elseif szb(2)==0 && (szb(1)==sza(1) | szb(1)==0)
         out = A;
      elseif sza(1)==szb(1)
         try
            out = binop(A,B,'horzcat');
         catch einfo
            throw(einfo);
         end
      else
         error('In [SYS1 , SYS2], SYS1 and SYS2 must have the same number of outputs.');
      end
   else
      out = horzcat(uss(varargin{1}),uss(varargin{2}));
   end
else
   out = horzcat(horzcat(uss(varargin{1}),uss(varargin{2})),varargin{3:end});
end



