function boo = isdt(sys)
%ISDT  True for discrete-time USS models.
%
%   ISDT(SYS) returns 1 (true) if the USS model
%   SYS is discrete (non-zero sampling time) or if
%   if it is a static gain.
%
%   See also ISCT, ISSTATIC.

% Copyright 2004 The MathWorks, Inc.

boo = sys.Ts~=0 || isstatic(sys);

