function boo = isstatic(sys)
%ISSTATIC  True for static gains
%
%   ISSTATIC(SYS) returns 1 (true) if the USS model SYS is a 
%   static gain, and 0 (false) otherwise.
%
%   For USS arrays, ISSTATIC(SYS) is true if all models in the
%   array are static gains.
%
%   See also POLE, ZERO.

% Copyright 2003-2004 The MathWorks, Inc.

% SYS is a static gain if it has no dynamics and no time delays

boo = length(sys.StateName)==0;
