%MKHEADER Create header for display of uncertain USS objects
%
%See also: DISPLAY

% Copyright 2003-2004 The MathWorks, Inc.
function out = mkheader(m)

%XXXDISPLAY
[rp,cp,nblk,iosize,blkiosize,szmd] = umatinfo(m.UmatData);
if length(szmd)==2
   arrstr = [];
elseif length(szmd)==3
   arrstr = [' [array, ' int2str(szmd(3)) ' x 1]'];
else
   arrstr = [int2str(szmd(3))];
   for i=4:length(szmd)
      arrstr = [arrstr ' x ' int2str(szmd(i))];
   end
   arrstr = [' [array, ' arrstr ']'];
end
Nx = length(m.StateName);
if Nx==1
	xstr = [int2str(Nx) ' State, '];
else
	xstr = [int2str(Nx) ' States, '];
end
if (iosize(1)-Nx)==1
   ystr = [int2str(iosize(1)-Nx) ' Output, '];
else
   ystr = [int2str(iosize(1)-Nx) ' Outputs, '];
end
if (iosize(2)-Nx)==1
   ustr = [int2str(iosize(2)-Nx) ' Input,'];
else
	ustr = [int2str(iosize(2)-Nx) ' Inputs,'];
end

Ts = pvget(m,'Ts');
if Ts==0
   tsstr = ' Continuous System';
elseif Ts>0
   tsstr = [' Discrete System, Ts = ' num2str(Ts)];
elseif Ts==-1
   tsstr = [' Discrete System, unspecified Ts'];
else
   tsstr = [' Static System, unspecified Ts'];
end

xioStr = [xstr ystr ustr tsstr];
out = [xioStr arrstr];