%MTIMES  Multiplication for USS objects

% Copyright 2003-2004 The MathWorks, Inc.
function out = mtimes(A,B)

if isa(A,'uss') & isa(B,'uss')
   sza = size(A);
   szb = size(B);
   if ~isexdok(sza(3:end),szb(3:end))
      error('Array dimensions are incompatible.')
   end
   if sza(2)==szb(1)
      try
         out = binop(A,B,'mtimes');
      catch einfo
         throw(einfo);
      end
   elseif sza(1)==1 & sza(2)==1 & szb(1)>0 & szb(2)>0
      Aext = A;
      for i=2:szb(1)
         Aext = blkdiag(Aext,A);
      end
      out = Aext*B;
   elseif szb(1)==1 & szb(2)==1 & sza(1)>0 & sza(2)>0
      Bext = B;
      for i=2:sza(2)
        Bext = blkdiag(Bext,B);
      end
      out = A*Bext;
   else
      error('In SYS1*SYS2, systems must have compatible dimensions.');
   end
   % no need to reduce.  all reduction takes place in each NDLFT/BINARYOP
   % no need to promote.  no depromotion ever takes place.
   %out = uss(genredu(out));
else
   out = uss(A)*uss(B);
end
