function n = ndims(a)
%NDIMS  Number of dimensions for USS objects.
%
%   N = NDIMS(USYS) returns the number of dimensions of
%   the uncertain systems USYS.  A single USS system has two 
%   dimensions (outputs and inputs).  An array of USS systems 
%   has 2+p dimensions, where p>=2 is the number of array 
%   dimensions.  For example, a 2-by-3-by-4 array of uncertain
%   systems has 2+3=5 dimensions.
%
%   See also SIZE.

% Copyright 2003-2004 The MathWorks, Inc.
n = length(size(a));