function m = parenget(m,L)
%PARENGET Low level get command for USS objects.

%   Copyright 2003-2007 The MathWorks, Inc.
%   $Revision: 1.1.6.3 $ $Date: 2007/06/07 14:46:00 $

% Convert Logicals to Doubles
for i=1:length(L)
   if isa(L{i},'logical');
      L{i} = find(L{i});
   end
end


%XXXOK
Nx = length(m.StateName);
[rp,cp,nblk,iosize,blkiosize,szmd] = umatinfo(m.UmatData);
sizes = [iosize-Nx szmd(3:end)];
L = utRefCheck(m.dynamicsys,L,sizes);

tmps.type = '()';
tmps.subs = L;
outds = subsref(m.dynamicsys,tmps);

L1 = L{1};
if strcmp(L1,':')
   L{1} = [1:Nx Nx+(1:sizes(1))];
else
   L{1} = [1:Nx reshape(L1,[1 length(L1)])+Nx];
end
L2 = L{2};
if strcmp(L2,':')
   L{2} = [1:Nx Nx+(1:sizes(2))];
else
   L{2} = [1:Nx reshape(L2,[1 length(L2)])+Nx];
end
UmatData = parenget(m.UmatData,L); % this is always a UMAT
m = uss(UmatData,m.StateName,m.Ts,outds);
