%PLUS  Addition for USS objects

% Copyright 2003-2004 The MathWorks, Inc.
function out = plus(A,B)

if isa(A,'uss') & isa(B,'uss')
   sza = size(A);
   szb = size(B);
   if ~isexdok(sza(3:end),szb(3:end))
      error('Array dimensions are incompatible.')
   end
   if sza(1)==1 & sza(2)==1 & (szb(1)>1 | szb(2)>1)
      Aext = ones(szb(1),1)*A*ones(1,szb(2));
      out = Aext+B;        
   elseif szb(1)==1 & szb(2)==1 & (sza(1)>1 | sza(2)>1)
      Bext = ones(sza(1),1)*B*ones(1,sza(2));
      out = A+Bext;        
   elseif sza(1)==szb(1) & sza(2)==szb(2)
      try
         out = binop(A,B,'plus');
      catch einfo
         throw(einfo);
      end
   else
      error('In SYS1+SYS2, systems must have same number of inputs and outputs.');
   end
else
   out = uss(A) + uss(B);
end



