function OMEGAsel = dkpickfreq(Pnom);

% Copyright 2004 The MathWorks, Inc.

[mag,ph,OMEGA] = genfresp(Pnom,4,[]);
range = log10(OMEGA(end))-log10(OMEGA(1));
ev = pole(Pnom);
dflag = 0;
if Pnom.Ts == 0 %continuous-time system
   evmin = min(abs(ev));
   evmax = max(abs(ev));
else
   [wnout,z,r]=damp(ev,Pnom.Ts);
   evmin = min(abs(r));
   evmax = max(abs(r));
   nfreq = 0.5/Pnom.Ts;
   if evmax > nfreq
      evmax = nfreq;
      dflag = 1;
   end
end
rangev = log10(evmax) - log10(evmin+eps);

if range>6
   if rangev<=6
      diff = 6-rangev;
      if dflag == 1 % max freq is the nyquist freq
         indx = find(OMEGA>=evmax*1e-5);
         OMEGAsel = OMEGA(indx);
      else
         diff = 6-rangev;
         indx = find(OMEGA<=(evmax*10^(diff/2)) & ...
            OMEGA>=(10^(-diff/2)*evmin));
         OMEGAsel = OMEGA(indx);
      end
   else
      if abs(evmin)<=1e-5
         indx = find(OMEGA<=9e2 & OMEGA>=1e-5);
         OMEGAsel = OMEGA(indx);
      else
         indx = find(OMEGA<=1e6*evmin & OMEGA>=evmin);
         OMEGAsel = OMEGA(indx);
      end
   end
else
   OMEGAsel = OMEGA;
end