function indices = mkLsubs(indices,sizes,ltiData)

% Copyright 2003-2004 The MathWorks, Inc.

% copy @lti code from indexref
nind = length(indices);
if nind==1,
   if length(sizes)>2 | min(sizes)>1,
      error('Use multiple indexing for MIMO models or LTI arrays, as in SYS(i,j).');
   elseif sizes(1)==1,  % 2D, single output
      indices = [{':'} indices];
   else                 % 2D, single input
      indices = [indices {':'}];
   end
elseif length(sizes)==2 & isequal(indices,{':' ':' 1}),
   % Quick exit for SYS(:,:,1) to optimize multi-model loops in single-model case
   return
end
% Check and format indices
indices = refchk(indices,sizes,ltiData);