%QBTRAN Coordinate transformation for USS object
%
%[SYST,HSV,T] = QBTRAN(SYS) returns the transformed USS
% object, SYST, the Hankel singular values associated with
%SYS, HSV, and the state transform matrix T.
%
%See Also: SSBAL

% Copyright 2003-2004 The MathWorks, Inc.
function [sysb,hsv,T] = qbtran(sys)

[tmp,T1] = ssbal(sys);
[tmpsys,tmpDelta] = lftdata(tmp);
[sm,hsv,errc,T2] = sbmudl(tmpsys);
sysb = lft(tmpDelta,sm);
T = T2*T1; % use as T A T^{-1}