function B = repmat(A,varargin)
% REPMAT Replicate and tile an array.
% 
% B = REPMAT(A,M,N) creates a large USS array B consisting of 
% an M-by-N tiling of copies of A.
% 
% B = REPMAT(A,[M N]) accomplishes the same result as REPMAT(A,M,N).
% 
% B = REPMAT(A,[M N P ...]) tiles the array A to produce a
% M-by-N-by-P-by-... block array.  A can be N-D.
% 
% See also BLKDIAG.

% Copyright 2003-2004 The MathWorks, Inc.

fbname = '_rcastreserved';
uresult = repmat(uss2umat(A,fbname),varargin{:});
UmatData = blk2ioch(uresult,fbname,'t','unchanged');
%B = uss(UmatData,A.StateName,A.Ts,repmat(A.dynamicsys,varargin{:}));
DS = [varargin{:}];
B = uss(UmatData,A.StateName,A.Ts,utRepSys(A.dynamicsys,DS));
