function [a,b,c,d,Ts] = ssdata(sys)
%SSDATA  Quick access to uncertain state-space data.
%
%[A,B,C,D] = SSDATA(SYS) retrieves the uncertain matrix data 
%A,B,C,D for the uncertain state-space model SYS.
%
%[A,B,C,D,TS] = SSDATA(SYS) also returns the sample time TS.
%Other properties of SYS can be accessed with GET or by direct 
%structure-like referencing (e.g., SYS.Ts).
%
%See also GET, USS

% Copyright 2003-2004 The MathWorks, Inc.

% Build A,B,C,D outputs
a = simplify(get(sys,'a'),'class');
b = simplify(get(sys,'b'),'class');
c = simplify(get(sys,'c'),'class');
d = simplify(get(sys,'d'),'class');

% Sample time
Ts = pvget(sys,'Ts');

