%PVGET  Get values of public WCGOPT properties.
%  
%VALUES = PVGET(MAT) returns all public values in a cell
%array VALUES.
%  
%VALUE = PVGET(SYS,PROPERTY) returns the value of the
%single property with name PROPERTY.
%  
%See also GET.

function [out,pflag,errstring] = pvget(m,property)
% Copyright 2003-2006 The MathWorks, Inc.

pflag = 1;
errstring = '';
loc = length(m.OptCell);

% ons = cell(loc,1);
% for i=1:loc
%    ons{i} = pvget(m.OptCell{i},'Name');
% end
ons = m.Cache.Names;

switch property
case ons
   idx = find(strcmp(ons,property));
   out = m.OptCell{idx};
   out = pvget(out,'Value');
case 'PropNames'
%    SPD = cell(loc,1);
%    for i=1:length(m.OptCell)
%       SPD{i} = pvget(m.OptCell{i},'String');
%    end
   SPD = m.Cache.Strings;
   GP = ons;
   SP = ons;
   GPend = {'Default';'Meaning'};
   out.GPropNames = [GP(1:5);GPend;GP(6:end)];
   out.SPropNames = SP;
   out.SPropDescription = SPD;
case 'OptNames'
   out = ons;
case 'Default'
   cc = cell(0,1);
   for i=1:length(m.OptCell)
      cc = [cc;{pvget(m.OptCell{i},'Name')};{pvget(m.OptCell{i},'Default')}];
   end
   out = struct(cc{:});
case 'OptCell'
   cc = cell(0,1);
   for i=1:length(m.OptCell)
      cc = [cc;{pvget(m.OptCell{i},'Name')};{m.OptCell{i}}];
   end
   out = struct(cc{:});
case 'Meaning'
   cc = cell(0,1);
   for i=1:length(m.OptCell)
      cc = [cc;{pvget(m.OptCell{i},'Name')};{pvget(m.OptCell{i},'String')}];
   end
   out = struct(cc{:});
otherwise
   out = [];
   pflag = 0;
   errstring = ['Invalid WCGOPT property: ''' property '''.'];
end
if nargout<=1 && pflag==0
   error(errstring);
end
