%PVSET  Set properties of WCGOPT objects.
%  
%OBJ = PVSET(OBJ,'Property1',Value1,'Property2',Value2,...)
%sets the values of the properties with exact names 'Property1',
%'Property2',...
%  
%See also SET.

function [m,pflag,errstring] = pvset(m,property,value)
% Copyright 2003-2004 The MathWorks, Inc.

pflag = 1;
errstring = '';
ons = pvget(m,'OptNames');
idx = find(strcmp(ons,property));
if length(idx)==1
   if isa(value,'optunit')
      m.OptCell{idx} = value;
   elseif isa(value,'char') & strncmpi('Default',value,length(value))
      m.OptCell{idx} = pvset(m.OptCell{idx},'Value',pvget(m.OptCell{idx},'Default'));
   elseif isa(value,class(pvget(m.OptCell{idx},'Value')))
      m.OptCell{idx} = pvset(m.OptCell{idx},'Value',value);
   else
      errstring = ['Value is incorrect type for property ' property];
      pflag = 0;
   end
else
   pflag = 0;
   errstring = ['Invalid WCGOPT property: ' property];
end
if nargout<=1 && pflag==0
   error(errstring);
end
