%BLK2IOCH Converts an uncertainty to an input/output block.
%
%[OUT,IDFLG] = BLK2IOCH(MAT,BLKID,TB) opens up a LFT channel, moving the 
%exposed inputs/outputs into the top (or bottom) of the I/O block. MAT is
%an uncertain matrix, BLKID is the name or numerical index of the uncertain 
%that is present in MAT and TB is a string that determines if the block 
%should be moved to the top, 't' or the bottom, 'b' of the inputs and outputs
%of OUT. OUT is an uncertain matrix with BLKID at either the top, if
%TB='t', or bottom, TB='b', of the inputs/outputs of the original uncertain
%matrix MAT. IDFLG is 1 if the BLKID was an uncertain atom in MAT otherwise
%it is 0.
%
%BLK2IOCH returns a UFRD object.
%
%See also: NORMALIZE


% function [out,idflg] = blk2ioch(mat,blkid,tb)
%
%  Opens up a LFT channel, moving the exposed
%  inputs/outputs into the top (or bottom) of
%  the I/O block.  Uses name in BLKID, or
%  numerical index.
%
%  Always returns a UFRD

% Copyright 2003-2004 The MathWorks, Inc.
function B = blk2ioch(A,dum1,dum2)

% XXXHELP, XXXCONSOLIDATE or get rid of?

estr = 'BLK2IOCH is only valid on UMAT, USS and UFRD classes.';
error(estr)