% Simulation environment of a 2-link planar manipulator
% Copyright 2011 Adriano Siqueira
% File sim_check_data.m
% Check for data consistency

% assume user data is correct
set(mc_error_data,'Visible','off');
check = 1;

% set pointer to watch
set(gcf,'Pointer','watch');

% check user data
if (length(init_cond) ~= n),
  init_cond = ic_dflt;
  check = 0;
elseif (length(set_point) ~= n),
  set_point = sp_dflt;
  check = 0;
elseif ((length(m) ~= n) | (any(m <= 0))),
  m = m_dflt;
  check = 0;
elseif ((length(l) ~= n) | (any(l <= 0))),
  l = l_dflt;
  check = 0;
elseif ((length(lc) ~= n-1) | (any(lc <= 0)) | (any(lc > l(1:2)))),
  lc = lc_dflt;
  check = 0;
elseif ((length(du) ~= 1) & (length(du) ~= 3) | any(du <= 0)),
  du = du_dflt;
  check = 0;
else
  vec_size = size(init_cond);
  if (vec_size(1) ~= n),
    init_cond = init_cond';
  end;
  vec_size = size(set_point);
  if (vec_size(1) ~= n),
    set_point = set_point';
  end;
  if (length(du) == 1),
    du = du*ones(1,3);
  end;
end;

% build messages from user data
if (~check),
   set(mc_error_data,'Visible','on');
else
   set(mc_error_data,'Visible','off');
end;


% display messages
sim_set_msg;

% return pointer to arrow
set(gcf,'Pointer','arrow');
