% Simulation environment of a 2-link planar manipulator
% Copyright 2011 Adriano Siqueira
% File sim_forw_kin.m
% Computes the forward kinematics of the 2-link robot

function [xy] = sim_forw_kin(theta,l)


COS1 = cos(theta(1));
SIN1 = sin(theta(1));
COS12 = cos(theta(1) + theta(2));
SIN12 = sin(theta(1) + theta(2));

xy(1,1) = l(1)*COS1 + l(2)*COS12;
xy(2,1) = l(1)*SIN1 + l(2)*SIN12;


return;
