
% Simulation environment of a 2-link planar manipulator
% Copyright 2011 Adriano Siqueira
% File sim_init_graph.m
% Initialize the graphics 

   
tempgrap = figure(...
  'Unit','normalized',...
  'NextPlot','add',...
  'Visible','off',...
  'NumberTitle','off',...
  'Position',[gui_x_pos,0.2,gui_x_size,gui_y_size/1.7],...
  'Name',eval(['sprintf(''%s Graphics'',cont_name)']),...
  'Pointer','arrow');
eval(['graphic_',cont,'=tempgrap;']);   
   
%create frames and display of graphics window
eval(['set(0,''Current'',graphic_',cont,')']);


% create necessary axes
tempgrap = axes(...
   'Units','normalized',...
   'Visible', 'on',...
  'Position',[.08 .25 .25 .7],...
  'XGrid','on',...
  'YGrid','on');
eval(['axis1_',cont,' = tempgrap;']);

xlabel('TIME (s)');
ylabel('JOINT ANGLES (degrees)');

tempgrap = axes(...
   'Units','normalized',...
   'Visible', 'on',...
  'Position',[.4 .25 .25 .7],...
  'XGrid','on',...
  'YGrid','on');
eval(['axis2_',cont,' = tempgrap;']);

xlabel('TIME (s)');
ylabel('JOINT VELOCITIES (deg/s)');

tempgrap = axes(...
   'Units','normalized',...
   'Visible', 'on',...
  'Position',[.72 .25 .25 .7],...
  'XGrid','on',...
  'YGrid','on');
eval(['axis3_',cont,' = tempgrap;']);

xlabel('TIME (s)');
ylabel('TORQUE (Nm)');

   
%create the button to close the figure
tempvar = sprintf('graphic_%s',cont);
tempgrap=[...
      sprintf('set(graphic_%s,''Visible'',''off'');',cont)...
      'set(0,''Current'',graph_interface);'...
      'set(graph_interface,''CurrentAxes'',movie_axis);'...
      'set(gcf,''Pointer'',''arrow'');'];
eval(['callclose_',cont,' = tempgrap;']);
%      'set(tempvar,''Visible'',''off'');'...

tempgrap=uicontrol(...
  'Style','push',...
  'Unit','normalized',...
  'Position',[pos_x1, 0.02, text_width_huge, 2.5*text_height],...
  'Horiz','left',...
  'Visible','on',...
  'String','Close',...
  'Callback',eval(['callclose_',cont]));
eval(['close_graphic_',cont,' = tempgrap;']);
   

