% Simulation environment of a 2-link planar manipulator
% Copyright 2011 Adriano Siqueira
% File sim_inv_kin.m
% Computes the inverse kinematics of the 2-link robot

function [q] = sim_inv_kin(l,x)

% check input and output arguments
if (nargin ~= 2),
  error('Wrong number of input arguments to UARM_INV_KIN.M');
end;

err = 0;

d = (x(1))^2 + (x(2))^2;
% check for existence of solution
if (sqrt(d) > l(1)+l(2)),
  err = 1;
  disp('Specified Cartesian point is beyond the reach of the arm');
end;
beta = atan2(x(2),x(1));
gamma = acos((d + l(1)^2 - l(2)^2) / (2*l(1)*sqrt(d)));
q(2,1) = acos((d - l(1)^2 - l(2)^2) / (2*l(1)*l(2)));
q(1,1) = beta - gamma*sign(q(2,1)) ;


return;
