% Simulation environment of a 2-link planar manipulator
% Copyright 2011 Adriano Siqueira
% File sim_jacob.m
% Computes the Jacobian matrix

function [J] = sim_jacob(theta,l)


COS1 = cos(theta(1));
SIN1 = sin(theta(1));
COS12 = cos(theta(1) + theta(2));
SIN12 = sin(theta(1) + theta(2));

J(1,1) = -l(1)*SIN1 - l(2)*SIN12;
J(1,2) = -l(2)*SIN12;

J(2,1) = l(1)*COS1 + l(2)*COS12;
J(2,2) = l(2)*COS12;





return;
