% Simulation environment of a 2-link planar manipulator
% Copyright 2011 Adriano Siqueira
% File sim_loop.m
% Implements the control loop

clc;
tic
%more on;

disp(['Computing till t = ', num2str(tfinal), ' s, please wait...']);
disp(' ');

for i = 1:max_sample,

    errorq = q_d(:,i) - theta;
    errorqd = qd_d(:,i) - omega;
    soma = soma + (errorq*dt);

    eq(:,i)=errorq;
    eqd(:,i)=errorqd;
    som(:,i)=soma;

    errorq_f = set_point-theta;
    errorqd_f = velocity_f-omega;


    % verify if active joints reached set-point
    for j = 1:n,
        if ((reach1(j) == 0) & ...
                (abs(errorq_f(j)) < max_error(1)) & ...
                (abs(errorqd_f(j)) < max_error(2))),
            reach1(j) = 1;
            count_reach1 = count_reach1 + 1;
            stat(j) = i*dt;
            set(motor(j),'Color',act_reach_color);
        end;
    end;


    if all(cont =='PID')
        kp = 2*[1 0;0 1];
        kv = 2*sqrt(kp);
        
        if ki_flag == 1
            ki = 0.5*[1 0;0 1];
        elseif ki_flag == -1
            ki = 0*[1 0;0 1];
        end

        % control law
        if grav_comp_flag == -1,
            tau(:,i) = kp*errorq + kv*errorqd + ki*soma;
            
           
        elseif grav_comp_flag == 1,
            tau(:,i) = kp*errorq + kv*errorqd + ki*soma + Gest;
        end





    elseif all(cont =='CTq')
        kp = 2*[1 0;0 1];
        kv = 2*sqrt(kp);
        

        % control law
        qdd_c(:,i) = kp*errorq + kv*errorqd + qdd_d(:,i);

        if grav_comp_flag == -1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i);

        elseif grav_comp_flag == 1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i) + Gest;

        end

        deltaest = inv(M)*(M - Mest);
        d = deltaest*qdd(:,i) + inv(M)*(C*qd(:,i) - Cest*qd(:,i));
        incerteza(:,i) = deltaest*(kp*errorq + kv*errorqd) + d;
        
        
        
        
% %         M11 = Mest(1,1);
% %         M12 = Mest(1,2);
% %         M21 = Mest(2,1);
% %         M22 = Mest(2,2);
% %         b1 = best(1);
% %         b2 = best(2);
% %         
% %         Mb = M12 - M11*inv(M21)*M22; 
% %         bb = b1 - inv(M21)*M22*b2;
% %         kp(2,2) = 1;
% %         kv(2,2) = 0.1;
% %         qdd_2(i) = kp(2,2)*errorq(2) + kv(2,2)*errorqd(2) + qdd_d(2,i);
% %         tau(1,i) = Mb*qdd_2(i) + bb;
% %         tau(2,i) = 0;
        
        
        
        
        
        
        

    elseif all(cont =='ADP')
        if i == 1
            kp = 2*[1 0;0 1];
            kv = 2*sqrt(kp);
           
            A = [zeros(2),eye(2);
                 -kp,-kv];
            Q = eye(4);
            P = lyap(A,Q);
            
            Gamma = [100 0;0 100];
            
            B=[zeros(2);eye(2)];
            Theta(:,1) = mest';
            
              Lambda = 2;
        end

        % control law

        alfa = qdd(:,i);
        YY = pr2l_adap(theta,omega,alfa,lest, lcest, grav);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        Thetad(:,i) = Gamma*YY'*inv(Mest)*B'*P*[errorq;errorqd];
        if i>1
          Theta(:,i) = Theta(:,i-1) + Thetad(:,i)*dt;
        end

        mest_adap = Theta(:,i)';
        [Mest,Cest,Gest,best] = pr2l_est(theta, omega, mest_adap, lest, lcest, grav);

        qdd_c(:,i) = kp*errorq + kv*errorqd + qdd_d(:,i);


        if grav_comp_flag == -1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i);

        elseif grav_comp_flag == 1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i) + Gest;

        end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        
% %          Thetad(:,i) = Gamma*YY'*(Lambda*errorq+errorqd);
% %         if i>1
% %             Theta(:,i) = Theta(:,i-1) + Thetad(:,i)*dt;
% %         end
% %         
% %         mest_adap = Theta(:,i)';
% %         [Mest,Cest,Gest,best] = pr2l_est(theta, omega, mest_adap, lest, lcest, grav);
% %         qdd_c(:,i) = qdd_d(:,i) + Lambda*errorqd;
% %         qd_c(:,i) = qd_d(:,i) + Lambda*errorq;
% %         
% %         if grav_comp_flag == -1,
% %             tau(:,i) = Mest*qdd_c(:,i) + Cest*qd_c(:,i);
% % 
% %         elseif grav_comp_flag == 1,
% %             tau(:,i) = Mest*qdd_c(:,i) + Cest*qd_c(:,i) + Gest;
% % 
% %         end
% %         
        
        

        
        
        
        
        
    elseif all(cont =='HIN')
        kp = 2*[1 0;0 1];
        kv = 2*sqrt(kp);
        
        % Controller design
        if i == 1,
           
            
                         fig=1;
                         [Ak,Bk,Ck,Dk,CL] = hin_2AA(kp,kv,fig);
            %
                         sysK=ss(Ak,Bk,Ck,Dk);
                         sysKd=c2d(sysK,dt,'tustin');
                         [Ak,Bk,Ck,Dk] = ssdata(sysKd);
            %
                         save hin.mat Ak Bk Ck Dk
            %
                         set(0,'Current',graph_interface);

            load hin.mat Ak Bk Ck Dk
            xk=zeros(size(Ak,1),max_sample);

        end




        % Dynamic control law
        y(:,i) = -[errorq];
        xk(:,i+1) = Ak*xk(:,i)+ Bk*y(:,i);
        u(:,i)  = Ck*xk(:,i)+ Dk*y(:,i);

        qdd_c(:,i) = kp*errorq + kv*errorqd + qdd_d(:,i) + u(:,i);

        if grav_comp_flag == -1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i);

        elseif grav_comp_flag == 1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i) + Gest;

        end

    elseif all(cont =='LPV')
        
        if i==1
            load feas.mat
        end

        errorqd = -errorqd;
        errorq = -errorq;

        B2 = [ eye(2);  zeros(2)];

        f1 = 1;
        f2(i) = cos(errorq(2));
     
        Xnlh =  f1*X1f + f2(i)*X2f;
        
%         Knlh = B2'*inv(Xnlh);
%         K11(i) = Knlh(1,1);
%         K12(i) = Knlh(1,2);
%         K13(i) = Knlh(1,3); 
         
        u(:,i) = - B2'*inv(Xnlh)*[errorqd;errorq];


        if grav_comp_flag == -1,
            tau(:,i) = Mest*(qdd_d(:,i) + u(:,i)) + Cest*qd_d(:,i);

        elseif grav_comp_flag == 1,
            tau(:,i) = Mest*(qdd_d(:,i) + u(:,i)) + Cest*qd_d(:,i) + Gest;

        end


    elseif all(cont =='CEV')
        Lambda = [2 0; 0 3];

        K = [.03 0;0 .02];
        r(:,i) = Lambda*errorq + errorqd;

        E = 0.01;
        for j=1:2,
            if (abs(r(j,i)) > E),
                sat(j,i) = sign(r(j,i));
            elseif (abs(r(j,i)) <= E),
                sat(j,i) = r(j,i)/E;
            end;
        end;

        qd_r(:,i) = Lambda*errorq + qd_d(:,i);
        qdd_r(:,i) = Lambda*errorqd + qdd_d(:,i);

        tau(:,i) = Mest*qdd_r(:,i) + Cest*qd_r(:,i) + Gest + K*sat(:,i);
        
        if grav_comp_flag == -1,
            tau(:,i) = Mest*qdd_r(:,i) + Cest*qd_r(:,i) + K*sat(:,i);

        elseif grav_comp_flag == 1,
            tau(:,i) = Mest*qdd_r(:,i) + Cest*qd_r(:,i) + Gest + K*sat(:,i);

        end

    elseif all(cont =='Car')
        kp=[1 0;0 1];
        kv= [1 0;0 1];
        ki = [0 0;0 0];
        % control law

        q_d(:,i) = sim_inv_kin(l,x_d(:,i));

        J = sim_jacob(theta,l);
        d(i) = det(J);
        Jinv(:,:,i) = inv(J);
        if i>1,
            Jinvd =   (Jinv(:,:,i) -  Jinv(:,:,i-1))/dt;
        else
            Jinvd =zeros(2);
        end

        qd_d(:,i) = inv(J)*xd_d(:,i);
        qdd_d(:,i) = inv(J)*xdd_d(:,i) + Jinvd*xd_d(:,i);

        errorq = q_d(:,i) -theta;
        errorqd = qd_d(:,i) -omega;


        qdd_c(:,i) = kp*errorq + kv*errorqd + ki*soma + qdd_d(:,i);
        if grav_comp_flag == -1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i);

        elseif grav_comp_flag == 1,
            tau(:,i) = Mest*qdd_c(:,i) + Cest*qd(:,i) + Gest;

        end


    end

    % Disturbances
    if dist_flag == 1

        for j=1:2,
            pert(j,i) = (amp(j)*exp(-((time(i)-tsalto(j))^2)/(2*dp(j)^2))*sin(freq(j)*pi*time(i)))';
        end

    end

    tau(:,i)= tau(:,i) + pert(:,i);

    if tor_flag == -1,
        tau(:,i) = [0;0];
        

    end

    for j=1:2,
        if tau(j,i)>tau_sat,
            tau(j,i)=tau_sat;
        end;
        if tau(j,i)<-tau_sat,
            tau(j,i)=-tau_sat;
        end;
    end;


    torque = tau(:,i);
    
    
    % invert dynamic model using Newton-Euler method
    W = inv(M);
    qdd(:,i+1) = W*(torque - b);
    qd(:,i+1) = qd(:,i) + qdd(:,i+1)*dt;
    q(:,i+1) = q(:,i) + qd(:,i+1)*dt + 0.5*qdd(:,i+1)*dt*dt;

    

    % correct q so that angles remain between -pi and pi
    index = find(q(1:2,i) < -pi);
    if (~isempty(index))
        q(index,i) = q(index,i) + 2*pi;
    end;
    index = find(q(1:2,i) > pi);
    if (~isempty(index))
        q(index,i) = q(index,i) - 2*pi;
    end;


    % update theta and omega
    theta = q(:,i);
    omega = qd(:,i);

    [M,C,G,b] = pr2l(theta, omega, m, l, lc, grav);
    [Mest,Cest,Gest,best] = pr2l_est(theta, omega, mest, lest, lcest, grav);


    % exit upon user's request
    if (terminate)
        break;
    end;
    time_clock = time_clock + dt;

    % exit after a while if control is finished
    if (count_reach1 == n),
        counter = counter + 1;
        if (counter >= run_after_done),
            break;
        end;
    end;

    % movie generation

    if (rem(i,graphic_step) == 0),
        % compute sum of joint angles
        for j = 1:2,
            phi(j) = sum(theta(1:j));
        end;
        cphi = cos(phi);
        sphi = sin(phi);
        % run forward kinematic to find out where joints are
        X(1) = 0;
        Y(1) = 0;
        for j = 2:2+1,
            X(j) = X(j-1) + l(j-1)*cphi(j-1);
            Y(j) = Y(j-1) + l(j-1)*sphi(j-1);
        end;
        % display the robot
        for j = 1:2+1,
            set(motor(j),'XData',X(j),'YData',Y(j));
        end;

        set(link,'XData',X,'YData',Y);
    end;
    if (rem(i,graphic_step) == 0),
        % adjust time


        set(time_value,'String',num2str(time_clock));

        drawnow;
    end;


end;

% calculation of time spent on loop
sim_time = toc;
disp(['Time spent on each control loop = ', ...
    num2str(sim_time/i), ' s']);
disp(['Total time spent on simulation  = ', num2str(sim_time), ' s']);
disp(' ');

% throw away unused portions of vectors
time = time(1:i-1);
tau = tau(:,1:i-1);
pert = pert(:,1:i-1);
u = u(:,1:i-1);
q = q(:,1:i-1);
qd = qd(:,1:i-1);
qdd = qdd(:,1:i-1);
q_d = q_d(:,1:i-1);
qd_d = qd_d(:,1:i-1);
qdd_d = qdd_d(:,1:i-1);
qdd_c = qdd_c(:,1:i-1);
eq=eq(:,1:i-1);
som=som(:,1:i-1);
eqd=eqd(:,1:i-1);
x_d = x_d(:,1:i-1);
xd_d = xd_d(:,1:i-1);
xdd_d = xdd_d(:,1:i-1);
x = x(:,1:i-1);
xd = xd(:,1:i-1);
xdd = xdd(:,1:i-1);
Theta=Theta(:,1:i-1);
Thetad=Thetad(:,1:i-1);
incerteza = incerteza(:,1:i-1);

qdd_r = qdd_r(:,1:i-1);
qd_r = qd_r(:,1:i-1);
r = r(:,1:i-1);
%f2 = f2(:,1:i-1);


% displays statistics about the simulation
disp(' ');
S = '';
S = sprintf('Set-points reached at ');
for k = 1:n,
    S = [S, sprintf('%4.2fs ', stat(k))];
end;
disp(S);
disp(' ');
S = '';
S = sprintf('Steady-state errors (deg): ');
for k = 1:n,
    S = [S, sprintf('%4.4f ', errorq(k)*180/pi)];
end;
disp(S);
disp(' ');

more off;

time_FT = time;
eval(['q_S_',cont,' = q;']);
eval(['qd_S_',cont,' = qd;']);
eval(['q_dS_',cont,' = q_d;']);
eval(['qd_dS_',cont,' = qd_d;']);
eval(['tau_S_',cont,' = tau;']);
eval(['time_S_',cont,' = time;']);


%generation of the graphics
sim_graph;
%if all(cont =='ADP'),
%    sim_graph_adp;
%end

set(0,'Current',graph_interface);


if (terminate == 1)
    terminate =0;
end;

disp(sprintf('\a')); % bell
disp(sprintf('\a')); % bell

% final touch
more off;
drawnow('discard');
