% Simulation environment of a 2-link planar manipulator
% Copyright 2011 Adriano Siqueira
% File sim_set_msg.m
% Reset the messages whenever a change occurs

% set pointer to watch
set(gcf,'Pointer','watch');

% build messages from user data
Sic = '';
Ssp = '';
Sm = '';
Sl = '';
Slc = '';
Sdu = '';
for i = 1:2,
  Sic = [Sic, sprintf('%.1f  ', init_cond(i)*180/pi)];
  Ssp = [Ssp, sprintf('%.1f  ', set_point(i)*180/pi)];
  Slc = [Slc, sprintf('%.2f  ', lc(i))];  
end  

for i = 1:n, 
  Sm = [Sm, sprintf('%.2f  ', m(i))];
  Sl = [Sl, sprintf('%.2f  ', l(i))];
end;
for i = 1:3
  Sdu = [Sdu, sprintf('%.1f  ', du(i))];
end;
Scont = sprintf(cont);

Straj = sprintf(traj_t);

% display messages
set(ic_dsp,'String',Sic);
set(sp_dsp,'String',Ssp);
set(mass_dsp,'String',Sm);
set(length_dsp,'String',Sl);
set(com_dsp,'String',Slc);
set(cont_dsp,'String',Scont);
set(traj_dsp,'String',Straj);
set(du_dsp,'String',Sdu);

if all(cont == 'PID'),
 set(uiKi,'Visible','on');
else
    set(uiKi,'Visible','off');
end
if ki_flag == 1,
 set(uiKi,'String','Ki on');
elseif ki_flag == -1
    set(uiKi,'String','Ki off');
end



% return pointer to arrow
set(gcf,'Pointer','arrow');
